'Class for HF / UHF
'Sascha Haveloh
's.haveloh@tec-tus.de
'Tectus Transponder Technology GmbH

Imports System
Imports System.Runtime.InteropServices
Imports System.Threading

Public Class RFIDFeig


#Region "FEIG constants WM_USER"
    Public Const WM_USER As Int32 = &H400

    Public WM_USER_CTS = WM_USER + 5
    Public WM_USER_RTS = WM_USER + 6
    Public WM_USER_DEVICE_DISCONNECT = WM_USER + 7
    Public WM_USER_DEVICE_CONNECT = WM_USER + 8

#End Region

#Region "FECOM constants"
    ' #####################################################
    ' FECOM constants
    ' #####################################################

    Public Const FECOM_ERR_NEWPORT_FAILURE = -1000
    Public Const FECOM_ERR_EMPTY_LIST = -1001
    Public Const FECOM_ERR_POINTER_IS_NULL = -1002
    Public Const FECOM_ERR_NO_MEMORY = -1003
    Public Const FECOM_ERR_UNSUPPORTED_HARDWARE = -1004
    Public Const FECOM_ERR_PORT_NOT_FOUND = -1005
    Public Const FECOM_ERR_UNSUPPORTED = -1006

    ' error while open the port
    Public Const FECOM_ERR_NO_PORT = -1010
    Public Const FECOM_ERR_NO_CONNECT = -1011
    Public Const FECOM_ERR_LINK_ID = -1012
    Public Const FECOM_ERR_PORT_IS_OPEN = -1013

    ' handle errors
    Public Const FECOM_ERR_UNKNOWN_HND = -1020
    Public Const FECOM_ERR_HND_IS_NULL = -1021
    Public Const FECOM_ERR_HND_IS_NEGATIVE = -1022
    Public Const FECOM_ERR_NO_HND_FOUND = -1023

    ' communication errors
    Public Const FECOM_ERR_TIMEOUT = -1030
    Public Const FECOM_ERR_NO_SENDPROTOCOL = -1031
    Public Const FECOM_ERR_RECEIVE_PROCESS = -1032
    Public Const FECOM_ERR_INIT_COMM_PROCESS = -1033
    Public Const FECOM_ERR_FLUSH_INPUT_BUFFER = -1034
    Public Const FECOM_ERR_FLUSH_OUTPUT_BUFFER = -1035
    Public Const FECOM_ERR_CHANGE_PORT_PARA = -1036
    Public Const FECOM_ERR_TRANSMIT_PROCESS = -1037
    Public Const FECOM_ERR_RECEIVE_NOISE_DATA = -1038
    Public Const FECOM_ERR_READ_PORT_PARA = -1039

    ' parameter errors
    Public Const FECOM_ERR_UNKNOWN_PARAMETER = -1050
    Public Const FECOM_ERR_PARAMETER_OUT_OF_RANGE = -1051
    Public Const FECOM_ERR_ODD_PARAMETERSTRING = -1052
    Public Const FECOM_ERR_PORTNR_OUT_OF_RANGE = -1053
    Public Const FECOM_ERR_UNKNOWN_ERRORCODE = -1054

    ' receive buffer overflow
    Public Const FECOM_ERR_OVL_RECBUF = -1070

    ' constants for dynamic load of library

    ' miscellaneous functions
    Public Const FECOM_GET_DLL_VERSION = 1000
    Public Const FECOM_GET_ERROR_TEXT = 1001
    Public Const FECOM_GET_LAST_ERROR = 1002
    Public Const FECOM_DETECT_PORT = 1003

    ' functions for event notification
    Public Const FECOM_ADD_EVENT_HANDLER = 1010
    Public Const FECOM_DEL_EVENT_HANDLER = 1011

    ' port functions
    Public Const FECOM_OPEN_PORT = 1020
    Public Const FECOM_CLOSE_PORT = 1021
    Public Const FECOM_GET_PORT_LIST = 1022
    Public Const FECOM_GET_PORT_PARA = 1023
    Public Const FECOM_SET_PORT_PARA = 1024
    Public Const FECOM_DO_PORT_CMD = 1025
    Public Const FECOM_GET_PORT_HND = 1026

    ' communication function
    Public Const FECOM__TRANSCEIVE = 1030
    Public Const FECOM__TRANSMIT = 1031
    Public Const FECOM__RECEIVE = 1032



    ' constants for structure _FECOM_EVENT_INIT

    ' defines for uiFlag in FECOM_EVENT_INIT
    Public Const FECOM_THREAD_ID = 1
    Public Const FECOM_WND_HWND = 2
    Public Const FECOM_CALLBACK = 3
    Public Const FECOM_EVENT = 4

    ' defines for uiUse in FECOM_EVENT_INIT
    Public Const FECOM_CTS_EVENT = 1
    Public Const FECOM_DCD_EVENT = 2
    Public Const FECOM_DSR_EVENT = 3
    Public Const FECOM_RTS_EVENT = 4
    Public Const FECOM_DTR_EVENT = 5

    Public Const FECOM_PORT_CLOSED_EVENT = 20    '' only for Windows CE (customized versions)
    Public Const FECOM_PORT_REOPEN_EVENT = 21 '	' only for Windows CE (customized versions) 

    ' #####################################################
    ' FECOM structures
    ' #####################################################
    ' structure for transfering thread-IDs, message-handles or callbacks
    ' structure for transfering callback functions
    Public Structure FECOM_EVENT_INIT
        Public uiUse As Integer
        Public uiMsg As Integer
        Public uiFlag As Integer
        Public Shared Method As DelgOnMessage
        'Public Method As DelgComInfo
        'Public hwndWnd As Integer
    End Structure

    Public Structure EventTest
        Public Event SayHallo()
        Public Sub DoEvent()
            RaiseEvent SayHallo()
        End Sub
    End Structure

#End Region


#Region "FEISC constants"
    ' #####################################################
    ' FEISC constants
    ' #####################################################

    ' command bytes
    Public Const FEISC_DESTROY = &H18
    Public Const FEISC_HALT = &H1A
    Public Const FEISC_RESET_QUIET_BIT = &H1B
    Public Const FEISC_EAS_REQUEST = &H1C
    Public Const FEISC_READ_BUFFER = &H21
    Public Const FEISC_ADV_READ_BUFFER = &H22
    Public Const FEISC_READ_BUFFER_INFO = &H31
    Public Const FEISC_CLEAR_BUFFER = &H32
    Public Const FEISC_INIT_BUFFER = &H33
    Public Const FEISC_FORCE_NOTIFY_TRIGGER = &H34
    Public Const FEISC_GET_BAUDRATE = &H52
    Public Const FEISC_START_FLASH_LOADER = &H55
    Public Const FEISC_START_FLASH_LOADER_EX = &H55
    Public Const FEISC_CPU_RESET = &H63
    Public Const FEISC_SYSTEM_RESET = &H64
    Public Const FEISC_SOFT_VERSION = &H65
    Public Const FEISC_READER_INFO = &H66
    Public Const FEISC_CHANNEL_ANALYZE = &H68
    Public Const FEISC_RF_RESET = &H69
    Public Const FEISC_RF_ON_OFF = &H6A
    Public Const FEISC_CENTRALIZED_RF_SYNC = &H6B
    Public Const FEISC_SET_NOISE_LEVEL = &H6C
    Public Const FEISC_GET_NOISE_LEVEL = &H6D
    Public Const FEISC_READER_DIAGNOSE = &H6E
    Public Const FEISC_ANTENNA_TUNING = &H6F
    Public Const FEISC_SET_OUTPUT = &H71
    Public Const FEISC_SET_OUTPUT_EX = &H72
    Public Const FEISC_GET_INPUT = &H74
    Public Const FEISC_ADJ_ANTENNA = &H75
    Public Const FEISC_READ_CONF_BLOCK = &H80
    Public Const FEISC_WRITE_CONF_BLOCK = &H81
    Public Const FEISC_SAVE_CONF_BLOCK = &H82
    Public Const FEISC_RESET_CONF_BLOCK = &H83
    Public Const FEISC_SET_CONF_MEM_LOC = &H84
    Public Const FEISC_SET_SYSTEM_TIMER = &H85
    Public Const FEISC_GET_SYSTEM_TIMER = &H86
    Public Const FEISC_SET_SYSTEM_DATE = &H87
    Public Const FEISC_GET_SYSTEM_DATE = &H88
    Public Const FEISC_READER_LOGIN = &HA0
    Public Const FEISC_WRITE_MIFARE_KEYS = &HA2
    Public Const FEISC_ISO_COMMAND = &HB0
    Public Const FEISC_ISO_CUST_PROP_CMD = &HB1
    Public Const FEISC_ISO_SP14443_COMMAND = &HB2
    Public Const FEISC_EPC_COMMAND = &HB3
    Public Const FEISC_EPC_UHF_COMMAND = &HB4
    Public Const FEISC_COMMAND_QUEUE = &HBC
    Public Const FEISC_ISO14443A_TRANSPARENT_CMD = &HBD
    Public Const FEISC_ISO14443B_TRANSPARENT_CMD = &HBE
    Public Const FEISC_ISO15693_TRANSPARENT_CMD = &HBF
    Public Const FEISC_SAM_COMMAND = &HC0


    ' error codes

    ' common errors
    Public Const FEISC_ERR_NEWREADER_FAILURE = -4000
    Public Const FEISC_ERR_EMPTY_LIST = -4001
    Public Const FEISC_ERR_POINTER_IS_NULL = -4002
    Public Const FEISC_ERR_NO_MORE_MEM = -4003
    Public Const FEISC_ERR_UNKNOWN_COMM_PORT = -4004
    Public Const FEISC_ERR_UNSUPPORTED_FUNCTION = -4005
    Public Const FEISC_ERR_NO_USB_SUPPORT = -4006
    Public Const FEISC_ERR_OLD_FECOM = -4007

    ' query errors
    Public Const FEISC_ERR_NO_VALUE = -4010

    ' handle errors
    Public Const FEISC_ERR_UNKNOWN_HND = -4020
    Public Const FEISC_ERR_HND_IS_NULL = -4021
    Public Const FEISC_ERR_HND_IS_NEGATIVE = -4022
    Public Const FEISC_ERR_NO_HND_FOUND = -4023
    Public Const FEISC_ERR_PORTHND_IS_NEGATIVE = -4024
    Public Const FEISC_ERR_HND_UNVALID = -4025

    ' communication errors
    Public Const FEISC_ERR_PROTLEN = -4030
    Public Const FEISC_ERR_CHECKSUM = -4031
    Public Const FEISC_ERR_BUSY_TIMEOUT = -4032
    Public Const FEISC_ERR_UNKNOWN_STATUS = -4033
    Public Const FEISC_ERR_NO_RECPROTOCOL = -4034
    Public Const FEISC_ERR_CMD_BYTE = -4035
    Public Const FEISC_ERR_TRANSCEIVE = -4036
    Public Const FEISC_ERR_REC_BUS_ADR = -4037

    ' parameter errors
    Public Const FEISC_ERR_UNKNOWN_PARAMETER = -4050
    Public Const FEISC_ERR_PARAMETER_OUT_OF_RANGE = -4051
    Public Const FEISC_ERR_ODD_PARAMETERSTRING = -4052
    Public Const FEISC_ERR_UNKNOWN_ERRORCODE = -4053
    Public Const FEISC_ERR_UNSUPPORTED_OPTION = -4054
    Public Const FEISC_ERR_UNKNOWN_EPC_TYPE = -4055

    ' plug-in errors
    Public Const FEISC_ERR_NO_PLUGIN = -4060
    Public Const FEISC_ERR_PLUGIN_PRESENT = -4061
    Public Const FEISC_ERR_UNKNOWN_PLUGIN_ID = -4062
    Public Const FEISC_ERR_PI_BUILD_DATA = -4063
    Public Const FEISC_ERR_PI_BUILD_FRAME = -4064
    Public Const FEISC_ERR_PI_SPLIT_FRAME = -4065
    Public Const FEISC_ERR_PI_SPLIT_DATA = -4066

    ' communication data flow errors
    Public Const FEISC_ERR_BUFFER_OVERFLOW = -4070

    ' task errors
    Public Const FEISC_ERR_TASK_STILL_RUNNING = -4080
    Public Const FEISC_ERR_TASK_NOT_STARTED = -4081
    Public Const FEISC_ERR_TASK_TIMEOUT = -4082
    Public Const FEISC_ERR_TASK_SOCKET_INIT = -4083
    Public Const FEISC_ERR_TASK_BUSY = -4084
    Public Const FEISC_ERR_THREAD_CANCEL_ERROR = -4085



    ' defines for uiFlag in FEISC_EVENT_INIT
    Public Const FEISC_THREAD_ID = 1
    Public Const FEISC_WND_HWND = 2
    Public Const FEISC_CALLBACK = 3
    Public Const FEISC_EVENT = 4
    Public Const FEISC_CALLBACK_2 = 5

    ' defines for uiUse in FEISC_EVENT_INIT
    Public Const FEISC_PRT_EVENT = 1
    Public Const FEISC_SNDPRT_EVENT = 2
    Public Const FEISC_RECPRT_EVENT = 3
    Public Const FEISC_SCANNER_EVENT = 4


    ' defines for uiFlag in FEISC_TAS_INIT
    Public Const FEISC_TASKCB_1 = 1
    Public Const FEISC_TASKCB_2 = 2

    ' defines for task identifier
    Public Const FEISC_TASKID_FIRST_NEW_TAG = 1
    Public Const FEISC_TASKID_EVERY_NEW_TAG = 2
    Public Const FEISC_TASKID_NOTIFICATION = 3
    Public Const FEISC_TASKID_SAM_COMMAND = 4
    Public Const FEISC_TASKID_COMMAND_QUEUE = 5

    ' defines for channel types in FEISC_TASK_INIT
    Public Const FEISC_TASK_CHANNEL_TYPE_AS_OPEN = 1   ' for open serial, usb, tcp channels
    Public Const FEISC_TASK_CHANNEL_TYPE_NEW_TCP = 5   ' for new tcp connection, established by host or reader

    Public Structure FEISC_EVENT_INIT
        Public uiUse As Integer
        Public uiMsg As Integer
        Public uiFlag As Integer
        Public Method As DelgOnMessage
    End Structure

    ' structure for transfering anything for an asynchronous task
    Public Structure FEISC_TASK_INIT
        Public pAny() As Byte
        Public ucBusAdr As Byte
        Public uiChannelType As Integer
        Public iConnectByHost As Integer
        Public cIPAdr() As Char
        Public iPortNr As Integer
        Public uiTimeout As Integer
        Public uiFlag As Integer
        Public Class dummy1
            Dim cbFct1 As Object
            Dim cbFct2 As Object
        End Class
        Public Class dummy2
            Dim iNotifyWithAck As Integer
        End Class
    End Structure

#End Region

#Region "ISC Reader constans"
    ' size of memories in bytes

    Public Const FEDM_ISC_MAX_EEDATA_MEM = 1024  ' memory for parameters in readers EEPROM
    Public Const FEDM_ISC_MAX_RAMDATA_MEM = 1024    ' memory for parameters in readers RAM
    Public Const FEDM_ISC_MAX_TMPDATA_MEM = 4096  ' memory for temporary data
    ' size of memories in bytes
    Public Const FEDM_ISC_MAX_RFC_EEDATA_MEM = 1024    ' memory for parameters in readers EEPROM
    Public Const FEDM_ISC_MAX_RFC_RAMDATA_MEM = 1024    ' memory for parameters in readers RAM
    Public Const FEDM_ISC_MAX_ACC_EEDATA_MEM = 8192    ' memory for parameters in readers EEPROM
    Public Const FEDM_ISC_MAX_ACC_RAMDATA_MEM = 8192    ' memory for parameters in readers RAM

    ' table types 
    ' (uiTableID in functions GetTableData, SetTableData, FindTableIndex,
    '	GetTableSize, ResetTable)
    Public Const FEDM_ISC_BRM_TABLE = 1
    Public Const FEDM_ISC_ISO_TABLE = 2
    Public Const FEDM_ISC_CAD_TABLE = 3


    ' access flags for the tables BRM and ISO
    ' (uiDataID in functions GetTableData, SetTableData, FindTableIndex, ResetTable)
    Public Const FEDM_ISC_DATA_TRTYPE = &H8000001  ' BRM and ISO
    Public Const FEDM_ISC_DATA_SNR = &H8000002 ' BRM and ISO
    Public Const FEDM_ISC_DATA_SNR_LEN = &H8000003  ' BRM and ISO
    Public Const FEDM_ISC_DATA_EPC = &H8000004  ' only ISO
    Public Const FEDM_ISC_DATA_EPC_HEADER = &H8000005  ' only ISO
    Public Const FEDM_ISC_DATA_EPC_DOMAIN = &H8000006  ' only ISO
    Public Const FEDM_ISC_DATA_EPC_OBJECT = &H8000007  ' only ISO
    Public Const FEDM_ISC_DATA_EPC_SNR = &H8000008  ' only ISO
    Public Const FEDM_ISC_DATA_EPC_TYPE = &H800000A  ' only ISO
    Public Const FEDM_ISC_DATA_AFI = &H800000B  ' only ISO
    Public Const FEDM_ISC_DATA_DSFID = &H800000C  ' only ISO
    Public Const FEDM_ISC_DATA_MEM_SIZE = &H800000D  ' only ISO
    Public Const FEDM_ISC_DATA_IC_REF = &H800000E  ' only ISO
    Public Const FEDM_ISC_DATA_TRINFO = &H800000F  ' only ISO14443A
    Public Const FEDM_ISC_DATA_OPTINFO = &H8000010  ' only ISO14443A
    Public Const FEDM_ISC_DATA_FSCI = &H8000011  ' only ISO14443-4
    Public Const FEDM_ISC_DATA_FWI = &H8000012  ' only ISO14443-4
    Public Const FEDM_ISC_DATA_DSI = &H8000013  ' only ISO14443-4
    Public Const FEDM_ISC_DATA_DRI = &H8000014  ' only ISO14443-4
    Public Const FEDM_ISC_DATA_NAD = &H8000015  ' only ISO14443-4
    Public Const FEDM_ISC_DATA_CID = &H8000016  ' only ISO14443-4
    Public Const FEDM_ISC_DATA_PROTOINFO = &H8000017  ' only ISO14443B
    Public Const FEDM_ISC_DATA_EPC_CL1_GEN2_PC = &H8000018  ' BRM and ISO
    Public Const FEDM_ISC_DATA_RxDB = &H4000001  ' BRM and ISO
    Public Const FEDM_ISC_DATA_TxDB = &H4000002  ' only ISO
    Public Const FEDM_ISC_DATA_SEC_STATUS = &H4000003  ' only ISO
    Public Const FEDM_ISC_DATA_BLOCK_SIZE = &H4000004  ' BRM and ISO
    Public Const FEDM_ISC_DATA_RxCB = &H2000001  ' only ISO
    Public Const FEDM_ISC_DATA_TxCB = &H2000002  ' only ISO
    Public Const FEDM_ISC_DATA_TIMER = &H1000001  ' only BRM
    Public Const FEDM_ISC_DATA_DB_ADR = &H1000002  ' only BRM
    Public Const FEDM_ISC_DATA_DBN = &H1000003  ' only BRM
    Public Const FEDM_ISC_DATA_ANT_NR = &H1000004  ' only BRM
    Public Const FEDM_ISC_DATA_DATE = &H1000005  ' only BRM
    Public Const FEDM_ISC_DATA_INPUT = &H1000006  ' only BRM
    Public Const FEDM_ISC_DATA_STATE = &H1000007  ' only BRM
    Public Const FEDM_ISC_DATA_IS_BLOCK_SIZE_SET = &H80000001  ' only ISO
    Public Const FEDM_ISC_DATA_IS_SELECTED = &H80000002  ' only ISO
    Public Const FEDM_ISC_DATA_IS_SNR = &H80000003  ' BRM and ISO
    Public Const FEDM_ISC_DATA_IS_EPC = &H80000004  ' only ISO
    Public Const FEDM_ISC_DATA_IS_AFI = &H80000005  ' only ISO
    Public Const FEDM_ISC_DATA_IS_DSFID = &H80000006  ' only ISO
    Public Const FEDM_ISC_DATA_IS_TRINFO = &H80000007  ' only ISO14443A
    Public Const FEDM_ISC_DATA_IS_SYSINFO = &H80000008    ' only ISO
    Public Const FEDM_ISC_DATA_IS_DB = &H80000009    ' only BRM
    Public Const FEDM_ISC_DATA_IS_TIMER = &H8000000A    ' only BRM
    Public Const FEDM_ISC_DATA_IS_ANT_NR = &H8000000B    ' only BRM
    Public Const FEDM_ISC_DATA_IS_DATE = &H8000000C    ' only BRM
    Public Const FEDM_ISC_DATA_IS_ISO14443_4_INFO = &H8000000D    ' only ISO14443-4
    Public Const FEDM_ISC_DATA_IS_INPUT = &H8000000E    ' only BRM
    Public Const FEDM_ISC_DATA_ALL = &HFFFF0000    ' for initialize all with ResetTable
    Public Const FEDM_ISC_DATA_MEM_SIZE_LEN = &H8000019  ' only ISO
    Public Const FEDM_ISC_DATA_CHIP_ID = &H8000020  ' only ISO
    Public Const FEDM_ISC_DATA_VALUE = &H4000005  ' only ISO


    ' only for EPCglobal Class1, Generation2 Transponder
    ' the user memory bank can be accessed with FEDM_ISC_DATA_RxDB and FEDM_ISC_DATA_TxDB
    Public Const FEDM_ISC_DATA_RxDB_EPC_BANK = &H4001001    ' only ISO
    Public Const FEDM_ISC_DATA_TxDB_EPC_BANK = &H4001002    ' only ISO
    Public Const FEDM_ISC_DATA_RxDB_TID_BANK = &H4001003    ' only ISO
    Public Const FEDM_ISC_DATA_TxDB_TID_BANK = &H4001004    ' only ISO
    Public Const FEDM_ISC_DATA_RxDB_RES_BANK = &H4001005    ' only ISO
    Public Const FEDM_ISC_DATA_TxDB_RES_BANK = &H4001006    ' only ISO


    ' access flags for the table CAD
    ' (uiDataID in functions GetTableData, ResetTable)
    Public Const FEDM_ISC_DATA_POWER_AVG = &H1    ' average power value
    Public Const FEDM_ISC_DATA_POWER_PEAK = &H2    ' peak power value
    Public Const FEDM_ISC_DATA_HISTORY_ALLOC = &H4    ' history record: allocation of channels
    Public Const FEDM_ISC_DATA_HISTORY_TX = &H8    ' history record: transmit channel
    Public Const FEDM_ISC_DATA_HISTORY_RX = &H10    ' history record: no. of receive channels
    Public Const FEDM_ISC_DATA_MISC = &H20  ' miscellaneous data


    ' ISO-Command mode flags
    Public Const FEDM_ISC_ISO_MODE_NONADR = &H0
    Public Const FEDM_ISC_ISO_MODE_ADR = &H1
    Public Const FEDM_ISC_ISO_MODE_SEL = &H2
    Public Const FEDM_ISC_ISO_MODE_SEC = &H8
    Public Const FEDM_ISC_ISO_MODE_WR_NE = &H8  ' only for jewel transponder
    Public Const FEDM_ISC_ISO_MODE_UID_LF = &H10
    Public Const FEDM_ISC_ISO_MODE_CINF = &H20  ' only for ISO14443-Transponder and [= &HB0][= &H25] Select
    Public Const FEDM_ISC_ISO_MODE_EXT_ADR = &H20
    Public Const FEDM_ISC_ISO_MODE_MORE = &H80

    ' ISO-Command bank identifier for:
    ' [0xB0][0x23] Read Multiple Blocks
    ' [0xB0][0x24] Write Multiple Blocks
    Public Const FEDM_ISC_ISO_BANK_RESERVED = &H0
    Public Const FEDM_ISC_ISO_BANK_EPC_MEMORY = &H1
    Public Const FEDM_ISC_ISO_BANK_TID_MEMORY = &H2
    Public Const FEDM_ISC_ISO_BANK_USER_MEMORY = &H3



    ' Manufacturer Code for [= &HB1] ISO-15693 Host Commands
    Public Const FEDM_ISC_ISO_MFR_PHILIPS = &H4
    Public Const FEDM_ISC_ISO_MFR_TI = &H7
    Public Const FEDM_ISC_ISO_MFR_NXP = &H4


    ' HF reader types
    Public Const FEDM_ISC_TYPE_ISCM01 = 30  ' listed, but unsupported
    Public Const FEDM_ISC_TYPE_ISCM02 = 31
    Public Const FEDM_ISC_TYPE_ISCLR100 = 40  ' listed, but unsupported
    Public Const FEDM_ISC_TYPE_ISCLR200 = 41
    Public Const FEDM_ISC_TYPE_ISCLR2000 = 42
    Public Const FEDM_ISC_TYPE_ISCPRH101 = 60
    Public Const FEDM_ISC_TYPE_ISCPRH101_U = 61
    Public Const FEDM_ISC_TYPE_ISCPRHD102 = 62
    Public Const FEDM_ISC_TYPE_ISCPRHD102_X = 50
    Public Const FEDM_ISC_TYPE_ISCPRH102 = 63
    Public Const FEDM_ISC_TYPE_ISCPRH100_U = 71
    Public Const FEDM_ISC_TYPE_ISCPRH100 = 72
    Public Const FEDM_ISC_TYPE_ISCMR100_U = 73
    Public Const FEDM_ISC_TYPE_ISCMR100 = 74
    Public Const FEDM_ISC_TYPE_ISCPR100 = 74
    Public Const FEDM_ISC_TYPE_ISCMR200 = 75
    Public Const FEDM_ISC_TYPE_ISCMR101 = 76
    Public Const FEDM_ISC_TYPE_ISCMR101_U = 78
    Public Const FEDM_ISC_TYPE_CPRM02 = 80
    Public Const FEDM_ISC_TYPE_CPR02 = 81
    Public Const FEDM_ISC_TYPE_CPR40_XX_U = 82
    Public Const FEDM_ISC_TYPE_CPR40_XX = 83
    Public Const FEDM_ISC_TYPE_CPR04_U = 88
    Public Const FEDM_ISC_TYPE_CPRM02_U = 82
    Public Const FEDM_ISC_TYPE_CPR02_U = 83
    Public Const FEDM_ISC_TYPE_CPRM03 = 84
    Public Const FEDM_ISC_TYPE_CPR03 = 85
    Public Const FEDM_ISC_TYPE_CPR04 = 87

    ' UHF reader types
    Public Const FEDM_ISC_TYPE_ISCMRU200 = 55
    Public Const FEDM_ISC_TYPE_ISCLRU1000 = 92
    Public Const FEDM_ISC_TYPE_ISCLRU2000 = 93
    Public Const FEDM_ISC_TYPE_ISCLRU3000 = 94


    ' name of readers
    Public Const FEDM_ISC_NAME_ISCM01 = "ID ISC.M01"
    Public Const FEDM_ISC_NAME_ISCM02 = "ID ISC.M02"
    Public Const FEDM_ISC_NAME_ISCLR100 = "ID ISC.LR100"
    Public Const FEDM_ISC_NAME_ISCLR200 = "ID ISC.LR200"
    Public Const FEDM_ISC_NAME_ISCLR2000 = "ID ISC.LR2000"
    Public Const FEDM_ISC_NAME_ISCLRM2000 = "ID ISC.LRM2000"
    Public Const FEDM_ISC_NAME_ISCPRH101 = "ID ISC.PRH101"
    Public Const FEDM_ISC_NAME_ISCPRH101_U = "ID ISC.PRH101-U"
    Public Const FEDM_ISC_NAME_ISCPRH102 = "ID ISC.PRH102"
    Public Const FEDM_ISC_NAME_ISCPRHD102 = "ID ISC.PRHD102"
    Public Const FEDM_ISC_NAME_ISCPRHD102_X = "ID ISCUM02/PRHD102"
    Public Const FEDM_ISC_NAME_ISCPRH100_U = "ID ISC.PRH100-U"
    Public Const FEDM_ISC_NAME_ISCPRH100 = "ID ISC.PRH100"
    Public Const FEDM_ISC_NAME_ISCMR100_U = "ID ISC.MR100-U"
    Public Const FEDM_ISC_NAME_ISCMR100 = "ID ISC.MR100"
    Public Const FEDM_ISC_NAME_ISCPR100 = "ID ISC.PR100"
    Public Const FEDM_ISC_NAME_ISCMR200 = "ID ISC.MR200"
    Public Const FEDM_ISC_NAME_ISCMR101 = "ID ISC.MR101"
    Public Const FEDM_ISC_NAME_ISCMR101_U = "ID ISC.MR101-U"
    Public Const FEDM_ISC_NAME_CPRM02_U = "ID CPR.M02-U"
    Public Const FEDM_ISC_NAME_CPR02_U = "ID CPR.02-U"
    Public Const FEDM_ISC_NAME_CPRM03 = "ID CPR.M03"
    Public Const FEDM_ISC_NAME_CPR03 = "ID CPR.03"
    Public Const FEDM_ISC_NAME_CPR04 = "ID CPR.04"
    Public Const FEDM_ISC_NAME_CPRM02 = "ID CPR.M02"
    Public Const FEDM_ISC_NAME_CPR02 = "ID CPR.02"
    Public Const FEDM_ISC_NAME_CPR04_U = "ID CPR.04-USB"
    Public Const FEDM_ISC_NAME_CPR40_XX_U = "ID CPR40.xx-U"
    Public Const FEDM_ISC_NAME_CPR40_XX = "ID CPR40.xx"

    Public Const FEDM_ISC_NAME_ISCMRU200 = "ID ISC.MRU200"         ' UHF
    Public Const FEDM_ISC_NAME_ISCLRU1000 = "ID ISC.LRU1000"        ' UHF
    Public Const FEDM_ISC_NAME_ISCLRMU1000 = "ID ISC.LRMU1000"       ' UHF
    Public Const FEDM_ISC_NAME_ISCLRU2000 = "ID ISC.LRU2000"        ' UHF
    Public Const FEDM_ISC_NAME_ISCLRMU2000 = "ID ISC.LRMU2000"       ' UHF
    Public Const FEDM_ISC_NAME_ISCLRU3000 = "ID ISC.LRU3000"        ' UHF


    ' HF transponder types
    Public Const FEDM_ISC_TR_TYPE_ICODE1 = &H0
    Public Const FEDM_ISC_TR_TYPE_TAGIT = &H1
    Public Const FEDM_ISC_TR_TYPE_ISO15693 = &H3
    Public Const FEDM_ISC_TR_TYPE_ISO14443A = &H4
    Public Const FEDM_ISC_TR_TYPE_ISO14443B = &H5
    Public Const FEDM_ISC_TR_TYPE_EPC = &H6
    Public Const FEDM_ISC_TR_TYPE_ICODE_UID = &H7
    Public Const FEDM_ISC_TR_TYPE_JEWEL = &H8
    Public Const FEDM_ISC_TR_TYPE_0x64 = &H64

    ' UHF transponder types
    Public Const FEDM_ISC_TR_TYPE_ISO18000_6_A = &H80
    Public Const FEDM_ISC_TR_TYPE_ISO18000_6_B = &H81
    Public Const FEDM_ISC_TR_TYPE_EM4222 = &H83
    Public Const FEDM_ISC_TR_TYPE_EPC_CLASS1_GEN2 = &H84
    Public Const FEDM_ISC_TR_TYPE_EPC_CLASS0 = &H88
    Public Const FEDM_ISC_TR_TYPE_EPC_CLASS1_GEN1 = &H89
    Public Const FEDM_ISC_TR_TYPE_EPC_GEN2_HF = &H9
    Public Const FEDM_ISC_TR_TYPE_STM_SR176 = &HA
    Public Const FEDM_ISC_TR_TYPE_STM_SRIxx = &HB
    Public Const FEDM_ISC_TR_TYPE_MCRF45x = &HC

    ' HF transponder names
    Public Const FEDM_ISC_TR_NAME_ICODE1 = "Philips I-Code1"
    Public Const FEDM_ISC_TR_NAME_TAGIT = "Texas Instruments Tag-it HF"
    Public Const FEDM_ISC_TR_NAME_ISO15693 = "ISO15693"
    Public Const FEDM_ISC_TR_NAME_ISO14443A = "ISO14443-A"
    Public Const FEDM_ISC_TR_NAME_ISO14443B = "ISO14443-B"
    Public Const FEDM_ISC_TR_NAME_EPC = "EPC"
    Public Const FEDM_ISC_TR_NAME_ICODE_UID = "I-CODE UID"
    Public Const FEDM_ISC_TR_NAME_JEWEL = "Innovision Jewel"
    Public Const FEDM_ISC_TR_NAME_0x64 = "ISO15693"
    Public Const FEDM_ISC_TR_NAME_EPC_GEN2_HF = "EPC Gen 2 HF"
    Public Const FEDM_ISC_TR_NAME_STM_SR176 = "STMicroelectronics SR176"
    Public Const FEDM_ISC_TR_NAME_STM_SRIxx = "STMicroelectronics SRIxx"
    Public Const FEDM_ISC_TR_NAME_MCRF45x = "Microchip MCRF45x"


    ' UHF transponder names
    Public Const FEDM_ISC_TR_NAME_ISO18000_6_A = "ISO18000-6-A"
    Public Const FEDM_ISC_TR_NAME_ISO18000_6_B = "ISO18000-6-B"
    Public Const FEDM_ISC_TR_NAME_EM4222 = "EM4222"
    Public Const FEDM_ISC_TR_NAME_EPC_CLASS0 = "EPC Class 0"
    Public Const FEDM_ISC_TR_NAME_EPC_CLASS1_GEN1 = "EPC Class 1 Gen 1"
    Public Const FEDM_ISC_TR_NAME_EPC_CLASS1_GEN2 = "EPC Class 1 Gen 2"


    ' EPC types (EPC = Electronic Product Code)
    Public Const FEDM_ISC_EPC_TYPE_1 = &H0  ' 96 bit EPC
    Public Const FEDM_ISC_EPC_TYPE_2 = &H1  ' 64 bit EPC Type I
    Public Const FEDM_ISC_EPC_TYPE_3 = &H2  ' 64 bit EPC Type II
    Public Const FEDM_ISC_EPC_TYPE_4 = &H3  ' 64 bit EPC Type III

    ' name of readers in UNICODE
    'Public Const FEDM_ISC_NAME_ISCM01_UC	=		"ID ISC.M01"
    Public Const FEDM_ISC_NAME_ISCM02_UC = "ID ISC.M02"
    'Public Const FEDM_ISC_NAME_ISCLR100_UC	=	"ID ISC.LR100"
    Public Const FEDM_ISC_NAME_ISCLR200_UC = "ID ISC.LR200"
    Public Const FEDM_ISC_NAME_ISCLR2000_UC = "ID ISC.LR2000"
    Public Const FEDM_ISC_NAME_ISCLRM2000_UC = "ID ISC.LRM2000"
    Public Const FEDM_ISC_NAME_ISCPRH101_UC = "ID ISC.PRH101"
    Public Const FEDM_ISC_NAME_ISCPRH101_U_UC = "ID ISC.PRH101-U"
    Public Const FEDM_ISC_NAME_ISCPRH102_UC = "ID ISC.PRH102"
    Public Const FEDM_ISC_NAME_ISCPRHD102_UC = "ID ISC.PRHD102"
    Public Const FEDM_ISC_NAME_ISCPRH100_U_UC = "ID ISC.PRH100-U"
    Public Const FEDM_ISC_NAME_ISCPRH100_UC = "ID ISC.PRH100"
    Public Const FEDM_ISC_NAME_ISCMR100_U_UC = "ID ISC.MR100-U"
    Public Const FEDM_ISC_NAME_ISCMR100_UC = "ID ISC.MR100"
    Public Const FEDM_ISC_NAME_ISCPR100_UC = "ID ISC.PR100"
    Public Const FEDM_ISC_NAME_ISCMR200_UC = "ID ISC.MR200"
    Public Const FEDM_ISC_NAME_ISCMR101_UC = "ID ISC.MR101"
    Public Const FEDM_ISC_NAME_ISCMR101_U_UC = "ID ISC.MR101-U"
    Public Const FEDM_ISC_NAME_CPRM02_UC = "ID CPR.M02"
    Public Const FEDM_ISC_NAME_CPR02_UC = "ID CPR.02"
    Public Const FEDM_ISC_NAME_CPR04_U_UC = "ID CPR.04-USB"
    Public Const FEDM_ISC_NAME_CPR40_XX_U_UC = "ID CPR40-xx-U"
    Public Const FEDM_ISC_NAME_CPR40_XX_UC = "ID CPR40-xx"
    Public Const FEDM_ISC_NAME_ISCMRU200_UC = "ID ISC.MRU200"        ' UHF
    Public Const FEDM_ISC_NAME_ISCLRU1000_UC = "ID ISC.LRU1000"       ' UHF
    Public Const FEDM_ISC_NAME_ISCLRMU1000_UC = "ID ISC.LRMU1000"      ' UHF
    Public Const FEDM_ISC_NAME_ISCLRU2000_UC = "ID ISC.LRU2000"       ' UHF
    Public Const FEDM_ISC_NAME_ISCLRMU2000_UC = "ID ISC.LRMU2000"      ' UHF
    Public Const FEDM_ISC_NAME_ISCLRU3000_UC = "ID ISC.LRU3000"       ' UHF


#End Region

#Region "FECOM DLL"


    ' #####################################################
    ' FECOM DLL 
    ' #####################################################

    <DllImport(dllName_com, EntryPoint:="FECOM_GetDLLVersion", SetLastError:=True)> _
    Private Shared Sub FECOM_GetDLLVersion(ByVal cVersion() As Byte)
    End Sub

    <DllImport(dllName_com, EntryPoint:="FECOM_OpenPort", SetLastError:=True)> _
    Private Shared Function FECOM_OpenPort(ByVal cPortNr As Byte()) As Integer
    End Function

    <DllImport(dllName_com, EntryPoint:="FECOM_ClosePort", SetLastError:=True)> _
    Private Shared Function FECOM_ClosePort(ByVal iPortHnd As Integer) As Integer
    End Function

    <DllImport(dllName_com, EntryPoint:="FECOM_SetPortPara", SetLastError:=True)> _
    Private Shared Function FECOM_SetPortPara(ByVal iPortHnd As Integer, ByVal cPara As Byte(), ByVal cValue As Byte()) As Integer
    End Function

    <DllImport(dllName_com, EntryPoint:="FECOM_DoPortCmd", SetLastError:=True)> _
    Private Shared Function FECOM_DoPortCmd(ByVal iPortHnd As Integer, ByVal cCmd As Byte(), ByVal cValue As Byte()) As Integer
    End Function

    <DllImport(dllName_com, EntryPoint:="FECOM_AddEventHandler", SetLastError:=True)> _
        Private Shared Function FECOM_AddEventHandler(ByVal iPortHnd As Integer, ByRef pInit As FECOM_EVENT_INIT) As Integer
    End Function


    Declare Function FECOM_GetErrorText Lib "fecomce.dll" Alias "FECOM_GetErrorText" (ByVal iErrorCode As Integer, ByRef cErrorText As String) As Integer
    Declare Function FECOM_GetLastError Lib "fecomce.dll" Alias "FECOM_GetLastError" (ByVal iPortHnd As Integer, ByRef iErrorCode As Integer, ByRef cErrorText As String) As Integer
    Declare Function FECOM_DetectPort Lib "fecomce.dll" Alias "FECOM_DetectPort" (ByVal iPortNr As Integer) As Integer
    'Declare Function FECOM_AddEventHandler Lib "fecomce.dll" Alias "FECOM_AddEventHandler" (ByVal iPortHnd As Integer, ByRef pInit As FECOM_EVENT_INIT) As Integer
    Declare Function FECOM_DelEventHandler Lib "fecomce.dll" Alias "FECOM_DelEventHandler" (ByVal iPortHnd As Integer, ByRef pInit As FECOM_EVENT_INIT) As Integer
    Declare Function FECOM_GetPortList Lib "fecomce.dll" Alias "FECOM_GetPortList" (ByVal iNext As Integer) As Integer
    Declare Function FECOM_GetPortPara Lib "fecomce.dll" Alias "FECOM_GetPortPara" (ByVal iPortHnd As Integer, ByRef cPara As String, ByRef cValue As String) As Integer
    Declare Function FECOM_GetPortHnd Lib "fecomce.dll" Alias "FECOM_GetPortHnd" (ByRef cPortNr As String) As Integer
    Declare Function FECOM_Transceive Lib "fecomce.dll" Alias "FECOM_Transceive" (ByVal iPortHnd As Integer, ByRef cSendProt As Byte, ByVal iSendLen As Integer, ByRef cRecProt As Byte, ByVal iRecLen As Integer) As Integer
    Declare Function FECOM_Transmit Lib "fecomce.dll" Alias "FECOM_Transmit" (ByVal iPortHnd As Integer, ByRef cSendProt As Byte, ByVal iSendLen As Integer) As Integer
    Declare Function FECOM_Receive Lib "fecomce.dll" Alias "FECOM_Receive" (ByVal iPortHnd As Integer, ByRef cRecProt As Byte, ByVal iRecLen As Integer) As Integer

#End Region

#Region "FEISC DLL"

    ' #####################################################
    ' FEISC declarate
    ' #####################################################

    <DllImport(dllName_isc, EntryPoint:="FEISC_SetReaderPara", SetLastError:=True)> _
    Private Shared Function FEISC_SetReaderPara(ByVal iReaderHnd As Integer, ByVal cPara() As Byte, ByVal cValue() As Byte) As Integer
    End Function

    <DllImport(dllName_isc, EntryPoint:="FEISC_GetDLLVersion", SetLastError:=True)> _
    Private Shared Sub FEISC_GetDLLVersion(ByVal cVersion() As Byte)
    End Sub

    <DllImport(dllName_isc, EntryPoint:="FEISC_NewReader", SetLastError:=True)> _
    Private Shared Function FEISC_NewReader(ByVal iPortHnd As Integer) As Integer
    End Function

    <DllImport(dllName_isc, EntryPoint:="FEISC_0x66_ReaderInfo", SetLastError:=True)> _
    Private Shared Function FEISC_0x66_ReaderInfo(ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cMode As Byte, ByVal cVersion() As Byte, ByVal iDataFormat As Integer) As Integer
    End Function

    <DllImport(dllName_isc, EntryPoint:="FEISC_0x65_SoftVersion", SetLastError:=True)> _
    Private Shared Function FEISC_0x65_SoftVersion(ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cVersion() As Byte, ByVal iDataFormat As Integer) As Integer
    End Function

    <DllImport(dllName_isc, EntryPoint:="FEISC_DeleteReader", SetLastError:=True)> _
    Private Shared Function FEISC_DeleteReader(ByVal iReaderHnd As Integer) As Integer
    End Function

    <DllImport(dllName_isc, EntryPoint:="FEISC_0x81_WriteConfBlock", SetLastError:=True)> _
    Private Shared Function FEISC_0x81_WriteConfBlock(ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cConfAdr As Byte, ByVal cConfBlock() As Byte, ByVal iDataFormat As Integer) As Integer
    End Function

    <DllImport(dllName_isc, EntryPoint:="FEISC_0x82_SaveConfBlock", SetLastError:=True)> _
    Private Shared Function FEISC_0x82_SaveConfBlock(ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cConfAdr As Byte) As Integer
    End Function

    <DllImport(dllName_isc, EntryPoint:="FEISC_0x69_RFReset", SetLastError:=True)> _
    Private Shared Function FEISC_0x69_RFReset(ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    End Function

    <DllImport(dllName_isc, EntryPoint:="FEISC_0xB0_ISOCmd", SetLastError:=True)> _
    Private Shared Function FEISC_0xB0_ISOCmd(ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cReqData() As Byte, ByVal iReqLen As Integer, ByVal cRspData() As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
    End Function

    <DllImport(dllName_isc, EntryPoint:="FEISC_0xB2_ISOCmd", SetLastError:=True)> _
    Private Shared Function FEISC_0xB2_ISOCmd(ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cReqData() As Byte, ByVal iReqLen As Integer, ByVal cRspData() As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
    End Function


    <DllImport(dllName_isc, EntryPoint:="FEISC_AddEventHandler", SetLastError:=True)> _
    Private Shared Function FEISC_AddEventHandler(ByVal iReaderHnd As Integer, ByRef pInit As FEISC_EVENT_INIT) As Integer
    End Function

    Public Declare Function FEISC_GetErrorText Lib "feiscce.dll" Alias "FEISC_GetErrorText" (ByVal iErrorCode As Integer, ByRef cErrorText As Char) As Integer
    Declare Function FEISC_GetStatusText Lib "feiscce.dll" Alias "FEISC_GetStatusText" (ByVal ucStatus As Byte, ByRef cStatusText As Char) As Integer
    'Declare Function FEISC_AddEventHandler Lib "feiscce.dll" Alias "FEISC_AddEventHandler" (ByVal iReaderHnd As Integer, ByRef pInit As FEISC_EVENT_INIT) As Integer
    Declare Function FEISC_DelEventHandler Lib "feiscce.dll" Alias "FEISC_DelEventHandler" (ByVal iReaderHnd As Integer, ByRef pInit As FEISC_EVENT_INIT) As Integer
    Declare Sub FEISC_SetCbPtr_ProtStr Lib "feiscce.dll" Alias "FEISC_SetCbPtr_ProtStr" (ByVal cbPtr() As Byte)
    Declare Function FEISC_GetReaderList Lib "feiscce.dll" Alias "FEISC_GetReaderList" (ByVal iNext As Integer) As Integer
    Declare Function FEISC_GetReaderPara Lib "feiscce.dll" Alias "FEISC_GetReaderPara" (ByVal iReaderHnd As Integer, ByRef cPara As Char, ByRef cValue As Char) As Integer
    Declare Function FEISC_InstallPlugIn Lib "feiscce.dll" Alias "FEISC_InstallPlugIn" (ByVal iReaderHnd As Integer, ByVal iPlugInID As Integer, ByVal pPlugIn() As Byte) As Integer
    Declare Function FEISC_RemovePlugIn Lib "feiscce.dll" Alias "FEISC_RemovePlugIn" (ByVal iReaderHnd As Integer, ByVal iPlugInID As Integer) As Integer
    Declare Function FEISC_StartAsyncTask Lib "feiscce.dll" Alias "FEISC_StartAsyncTask" (ByVal iReaderHnd As Integer, ByVal iTaskID As Integer, ByRef pInit As FEISC_TASK_INIT, ByVal pInput() As Byte) As Integer
    Declare Function FEISC_CancelAsyncTask Lib "feiscce.dll" Alias "FEISC_CancelAsyncTask" (ByVal iReaderHnd As Integer) As Integer
    Declare Function FEISC_TriggerAsyncTask Lib "feiscce.dll" Alias "FEISC_TriggerAsyncTask" (ByVal iReaderHnd As Integer) As Integer
    Declare Function FEISC_BuildSendProtocol Lib "feiscce.dll" Alias "FEISC_BuildSendProtocol" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cCmdByte As Byte, ByRef cSendData As Byte, ByVal iDataLen As Integer, ByRef cSendProt As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_BuildRecProtocol Lib "feiscce.dll" Alias "FEISC_BuildRecProtocol" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cCmdByte As Byte, ByVal cStatus As Byte, ByRef cRecData As Byte, ByVal iDataLen As Integer, ByRef cRecProt As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_SplitSendProtocol Lib "feiscce.dll" Alias "FEISC_SplitSendProtocol" (ByVal iReaderHnd As Integer, ByRef cSendProt As Byte, ByVal iSendLen As Integer, ByRef cBusAdr As Byte, ByRef cCmdByte As Byte, ByRef cSendData As Byte, ByRef iDataLen As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_SplitRecProtocol Lib "feiscce.dll" Alias "FEISC_SplitRecProtocol" (ByVal iReaderHnd As Integer, ByRef cRecProt As Byte, ByVal iRecLen As Integer, ByRef cBusAdr As Byte, ByRef cCmdByte As Byte, ByRef cRecData As Byte, ByRef iDataLen As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_Conv2StdProtocol Lib "feiscce.dll" Alias "FEISC_Conv2StdProtocol" (ByRef cProt As Byte, ByVal iLen As Integer) As Integer
    Declare Function FEISC_Conv2AdvProtocol Lib "feiscce.dll" Alias "FEISC_Conv2AdvProtocol" (ByRef cProt As Byte, ByVal iLen As Integer) As Integer
    Declare Function FEISC_GetLastSendProt Lib "feiscce.dll" Alias "FEISC_GetLastSendProt" (ByVal iReaderHnd As Integer, ByRef cSendProt As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_GetLastRecProt Lib "feiscce.dll" Alias "FEISC_GetLastRecProt" (ByVal iReaderHnd As Integer, ByRef cRecProt As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_GetLastState Lib "feiscce.dll" Alias "FEISC_GetLastState" (ByVal iReaderHnd As Integer, ByRef cStateText As Char) As Integer
    Declare Function FEISC_GetLastRecProtLen Lib "feiscce.dll" Alias "FEISC_GetLastRecProtLen" (ByVal iReaderHnd As Integer) As Integer
    Declare Function FEISC_GetLastError Lib "feiscce.dll" Alias "FEISC_GetLastError" (ByVal iReaderHnd As Integer, ByRef iErrorCode As Integer, ByRef cErrorText As Char) As Integer
    Declare Function FEISC_SendTransparent Lib "feiscce.dll" Alias "FEISC_SendTransparent" (ByVal iReaderHnd As Integer, ByRef cSendProt As Byte, ByVal iSendLen As Integer, ByRef cRecProt As Byte, ByVal iMaxRecLen As Integer, ByVal iCheckSum As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_Transmit Lib "feiscce.dll" Alias "FEISC_Transmit" (ByVal iReaderHnd As Integer, ByRef cSendProt As Byte, ByVal iSendLen As Integer, ByVal iCheckSum As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_Receive Lib "feiscce.dll" Alias "FEISC_Receive" (ByVal iReaderHnd As Integer, ByRef cRecProt As Byte, ByVal iMaxRecLen As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0x18_Destroy Lib "feiscce.dll" Alias "FEISC_0x18_Destroy" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal ucMode As Byte, ByRef ucEPC As Byte, ByRef ucPW As Byte) As Integer
    Declare Function FEISC_0x1A_Halt Lib "feiscce.dll" Alias "FEISC_0x1A_Halt" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    Declare Function FEISC_0x1B_ResetQuietBit Lib "feiscce.dll" Alias "FEISC_0x1B_ResetQuietBit" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    Declare Function FEISC_0x1C_EASRequest Lib "feiscce.dll" Alias "FEISC_0x1C_EASRequest" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    Declare Function FEISC_0x21_ReadBuffer Lib "feiscce.dll" Alias "FEISC_0x21_ReadBuffer" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cSets As Byte, ByRef cTrData As Byte, ByRef cRecSets As Byte, ByRef cRecDataSets As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0x22_ReadBuffer Lib "feiscce.dll" Alias "FEISC_0x22_ReadBuffer" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal iSets As Integer, ByRef cTrData As Byte, ByRef iRecSets As Integer, ByRef cRecDataSets As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0x31_ReadDataBufferInfo Lib "feiscce.dll" Alias "FEISC_0x31_ReadDataBufferInfo" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cTabSize As Byte, ByRef cTabStart As Byte, ByRef cTabLen As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0x32_ClearDataBuffer Lib "feiscce.dll" Alias "FEISC_0x32_ClearDataBuffer" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    Declare Function FEISC_0x33_InitBuffer Lib "feiscce.dll" Alias "FEISC_0x33_InitBuffer" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    Declare Function FEISC_0x34_ForceNotifyTrigger Lib "feiscce.dll" Alias "FEISC_0x34_ForceNotifyTrigger" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cMode As Byte) As Integer
    Declare Function FEISC_0x52_GetBaud Lib "feiscce.dll" Alias "FEISC_0x52_GetBaud" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    Declare Function FEISC_0x55_StartFlashLoader Lib "feiscce.dll" Alias "FEISC_0x55_StartFlashLoader" (ByVal iReaderHnd As Integer) As Integer
    Declare Function FEISC_0x55_StartFlashLoaderEx Lib "feiscce.dll" Alias "FEISC_0x55_StartFlashLoaderEx" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    Declare Function FEISC_0x63_CPUReset Lib "feiscce.dll" Alias "FEISC_0x63_CPUReset" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    Declare Function FEISC_0x64_SystemReset Lib "feiscce.dll" Alias "FEISC_0x64_SystemReset" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cMode As Byte) As Integer
    Declare Function FEISC_0x68_ChannelAnalyze Lib "feiscce.dll" Alias "FEISC_0x68_ChannelAnalyze" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cMode As Byte, ByVal cRes1 As Byte, ByVal cRes2 As Byte, ByVal cRes3 As Byte, ByVal iRes4 As Integer, ByRef nData As Integer) As Integer
    Declare Function FEISC_0x6A_RFOnOff Lib "feiscce.dll" Alias "FEISC_0x6A_RFOnOff" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cRF As Byte) As Integer
    Declare Function FEISC_0x6B_InitNoiseThreshold Lib "feiscce.dll" Alias "FEISC_0x6B_InitNoiseThreshold" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    Declare Function FEISC_0x6B_CentralizedRFSync Lib "feiscce.dll" Alias "FEISC_0x6B_CentralizedRFSync" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cMode As Byte, ByVal cTxChannel As Byte, ByVal iTxPeriod As Integer, ByVal cRes1 As Byte, ByVal cRes2 As Byte) As Integer
    Declare Function FEISC_0x6C_SetNoiseLevel Lib "feiscce.dll" Alias "FEISC_0x6C_SetNoiseLevel" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cLevel As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0x6D_GetNoiseLevel Lib "feiscce.dll" Alias "FEISC_0x6D_GetNoiseLevel" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cLevel As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0x6E_RdDiag Lib "feiscce.dll" Alias "FEISC_0x6E_RdDiag" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cMode As Byte, ByRef cData As Byte) As Integer
    Declare Function FEISC_0x6F_AntennaTuning Lib "feiscce.dll" Alias "FEISC_0x6F_AntennaTuning" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte) As Integer
    Declare Function FEISC_0x71_SetOutput Lib "feiscce.dll" Alias "FEISC_0x71_SetOutput" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal iOS As Integer, ByVal iOSF As Integer, ByVal iOSTime As Integer, ByVal iOutTime As Integer) As Integer
    Declare Function FEISC_0x72_SetOutput Lib "feiscce.dll" Alias "FEISC_0x72_SetOutput" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cMode As Byte, ByVal cOutN As Byte, ByRef pRecords As Byte) As Integer
    Declare Function FEISC_0x74_ReadInput Lib "feiscce.dll" Alias "FEISC_0x74_ReadInput" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cInput As Byte) As Integer
    Declare Function FEISC_0x75_AdjAntenna Lib "feiscce.dll" Alias "FEISC_0x75_AdjAntenna" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cValue As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0x80_ReadConfBlock Lib "feiscce.dll" Alias "FEISC_0x80_ReadConfBlock" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cConfAdr As Byte, ByRef cConfBlock As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0x83_ResetConfBlock Lib "feiscce.dll" Alias "FEISC_0x83_ResetConfBlock" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cConfAdr As Byte) As Integer
    Declare Function FEISC_0x84_SetCFGMemLoc Lib "feiscce.dll" Alias "FEISC_0x84_SetCFGMemLoc" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cMemAdr As Byte) As Integer
    Declare Function FEISC_0x85_SetSysTimer Lib "feiscce.dll" Alias "FEISC_0x85_SetSysTimer" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cTime As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0x86_GetSysTimer Lib "feiscce.dll" Alias "FEISC_0x86_GetSysTimer" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cTime As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0x87_SetSystemDate Lib "feiscce.dll" Alias "FEISC_0x87_SetSystemDate" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cCentury As Byte, ByVal cYear As Byte, ByVal cMonth As Byte, ByVal cDay As Byte, ByVal cTimezone As Byte, ByVal cHour As Byte, ByVal cMinute As Byte, ByVal iMilliSecond As Integer) As Integer
    Declare Function FEISC_0x88_GetSystemDate Lib "feiscce.dll" Alias "FEISC_0x88_GetSystemDate" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cCentury As Byte, ByRef cYear As Byte, ByRef cMonth As Byte, ByRef cDay As Byte, ByRef cTimezone As Byte, ByRef cHour As Byte, ByRef cMinute As Byte, ByRef iMilliSecond As Integer) As Integer
    Declare Function FEISC_0xA0_RdLogin Lib "feiscce.dll" Alias "FEISC_0xA0_RdLogin" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cRd_PW As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0xA2_WriteMifareKeys Lib "feiscce.dll" Alias "FEISC_0xA2_WriteMifareKeys" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal c_Type As Byte, ByVal cAdr As Byte, ByRef cKey As Byte, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0xB1_ISOCust Lib "feiscce.dll" Alias "FEISC_0xB1_ISOCust" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cMfr As Byte, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef cRspData As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0xB3_EPCCmd Lib "feiscce.dll" Alias "FEISC_0xB3_EPCCmd" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef cRspData As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0xB4_EPC_UHF_Cmd Lib "feiscce.dll" Alias "FEISC_0xB4_EPC_UHF_Cmd" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal cMfr As Byte, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef cRspData As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0xBC_CmdQueue Lib "feiscce.dll" Alias "FEISC_0xBC_CmdQueue" (ByVal iReaderHnd As Integer, ByVal iMode As Integer, ByVal iCmdNo As Integer, ByRef cCmdQueue As Byte, ByVal iCmdQueueLen As Integer, ByRef pInit As FEISC_TASK_INIT) As Integer
    Declare Function FEISC_0xBD_ISOTranspCmd Lib "feiscce.dll" Alias "FEISC_0xBD_ISOTranspCmd" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal iMode As Integer, ByVal iRspLength As Integer, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef cRspData As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0xBE_ISOTranspCmd Lib "feiscce.dll" Alias "FEISC_0xBE_ISOTranspCmd" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal iMode As Integer, ByVal iRspLength As Integer, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef cRspData As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0xBF_ISOTranspCmd Lib "feiscce.dll" Alias "FEISC_0xBF_ISOTranspCmd" (ByVal iReaderHnd As Integer, ByVal cBusAdr As Byte, ByVal iMode As Integer, ByVal iRspLength As Integer, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef cRspData As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
    Declare Function FEISC_0xC0_SAMCmd Lib "feiscce.dll" Alias "FEISC_0xC0_SAMCmd" (ByVal iReaderHnd As Integer, ByVal iSlot As Integer, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef pInit As FEISC_TASK_INIT) As Integer
#End Region

#Region "Reader Vaiablen"

    Private Const dllName_com As String = "fecomce_mc9090.dll"
    Private Const dllName_isc As String = "feiscce_mc9090.dll"
    Private Read_Array() As Byte 'Data of last Read operation
    Private Write_Array() As Byte 'Data of last Read operation
    Private Config_Array() As Byte ' Confog array for ISO Scan or ISO Host Mode
    Private Info_Array() As Byte 'Data for the ReaderInfo
    Private My_ComArray() As Byte
    Public InfoReader() As String
    Private cReqData() As Byte
    Private cRspData() As Byte
    Private UID_Array() As Byte
    Private UID_Array24() As Byte
    Private Value_Array() As Byte

    Private SelMifare_Array() As Byte
    Private Key_Array() As Byte
    Private ReadMi_Array() As Byte
    Private WriteMi_Array() As Byte

    Private iReaderHnd As Integer
    Private iPortHnd As Integer
    Private iDataType As Byte = 0
    Private iRspLen As Integer
    Private iReqLen As Integer
    Private cBusAdr As Byte = 255
    Private cMode As Byte = 0

    Private sBaud As String = "38400"
    Private sFrame As String = "8E1"
    Private sTimeout As String = "1000"
    Private R_Result As Integer
    Public UIDNr As String = ""
    Public BlockDataHex As String = ""
    Public BlockDataAScII As String = ""

    Public IsUHF As Boolean = False
    Public IsHF As Boolean = False
    Public TagTyp As String
    Public COMVersion As String
    Public ISCVersion As String
    Public ReaderInfo As String
    Public SoftwareInfo As String
    Private Info_Text As String
    Public IsActive As Boolean = False
    Public IsSascha As Boolean = False
    Public m_Init As FECOM_EVENT_INIT
    Public LastCTS As Boolean
    Public MifareKey As String
    Public LastErrorID As Integer

    Public Delegate Sub DelgOnMessage(ByVal wParam As IntPtr, ByVal lParam As IntPtr)
    Public Delegate Sub DelgComInfo(ByVal wParam As IntPtr, ByVal lParam As IntPtr)


#End Region

#Region "Events"
    ' These events allow the program using this class to react to Comm Port
    '   events.
    '    Public Event GetReaderText(ByVal Source As RFIDFeig, ByVal Info_Text As String)
    Public Event GetReaderText(ByVal Info_Text As String)

    Public Event GetBlockData(ByVal BlockNr As Integer, ByVal BlockData As String)
    Public Event IsReaderDown(ByVal IsDown As Boolean)


#End Region

#Region "Add Events"

#End Region

#Region "Sub and Funtion"

    Public Function stringToByteArray(ByVal str As String) As Byte()
        '---e.g. "abcdefg" to {a,b,c,d,e,f,g}
        Dim s As Char()
        s = str.ToCharArray
        Dim b(s.Length - 1) As Byte
        Dim i As Integer
        For i = 0 To s.Length - 1
            b(i) = Convert.ToByte(s(i))
        Next
        Return b
    End Function

    Function byteArrayToString(ByVal b() As Byte) As String
        '---e.g. {a,b,c,d,e,f,g} to "abcdefg" 
        Dim str As String
        Dim enc As System.Text.ASCIIEncoding
        enc = New System.Text.ASCIIEncoding
        str = enc.GetString(b, 0, b.Length())
        Return str
    End Function

    Public Sub ClearStringArray(ByRef src As String())
        Dim i As Integer
        For i = src.GetLowerBound(0) To src.GetUpperBound(0)
            src(i) = ""
        Next i
    End Sub

    Public Sub ClearArray(ByRef src As Byte())
        Dim i As Integer
        For i = src.GetLowerBound(0) To src.GetUpperBound(0)
            src(i) = 0
        Next i
    End Sub

    Public Function GetByteDataBufferToHex(ByVal Src As Byte(), ByVal BStart As Integer, ByVal BStop As Integer) As String
        Dim i As Integer
        Dim tmp As String
        GetByteDataBufferToHex = ""
        For i = BStart To BStop
            tmp = ""
            tmp = Hex(Src(i))
            If Len(tmp) = 1 Then
                tmp = "0" & tmp
            End If
            GetByteDataBufferToHex &= tmp
        Next i
        Return GetByteDataBufferToHex
    End Function

    Public Function GetInverted(ByVal Data As String) As String
        Dim i As Integer
        GetInverted = ""
        For i = Data.Length - 1 To 0 Step -1
            GetInverted = GetInverted + Data(i)
        Next
        Return GetInverted
    End Function

    Public Function GetByteDataBufferToHexInverted(ByVal Src As Byte(), ByVal BStart As Integer, ByVal BStop As Integer) As String
        Dim i As Integer
        Dim tmp As String
        GetByteDataBufferToHexInverted = ""
        For i = BStop To BStart Step -1
            tmp = ""
            tmp = Hex(Src(i))
            If Len(tmp) = 1 Then
                tmp = "0" & tmp
            End If
            GetByteDataBufferToHexInverted &= tmp
        Next i
        Return GetByteDataBufferToHexInverted
    End Function

    Public Function GetByteBufferToHex(ByVal Src As Byte(), ByVal DataLen As Integer) As String
        Dim i As Integer
        Dim tmp As String
        GetByteBufferToHex = ""
        For i = 0 To DataLen - 1
            tmp = ""
            tmp = Hex(Src(i))
            If Len(tmp) = 1 Then
                tmp = "0" & tmp
            End If
            GetByteBufferToHex &= tmp
        Next i
        Return GetByteBufferToHex
    End Function


    Public Function SetRTS(ByVal cmd As String) As Boolean
        SetRTS = False
        R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("SetRTS"), GetASCIIByte(cmd))
        SetRTS = R_Result = 0
    End Function

    Public Function GetRTS() As String
        GetRTS = ""
        R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetRTS"), Value_Array)
        If R_Result = 0 Then
            GetRTS = Trim(ByteToASCII(Value_Array))
        End If
    End Function

    Public Function SetDTR(ByVal cmd As String) As Boolean
        SetDTR = False
        R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("SetDTR"), GetASCIIByte(cmd))
        SetDTR = R_Result = 0
    End Function

    Public Function GetDTR() As String
        GetDTR = ""
        R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetDTR"), Value_Array)
        If R_Result = 0 Then
            GetDTR = Trim(ByteToASCII(Value_Array))
        End If
    End Function


    Public Function GetCTS() As String
        GetCTS = ""
        R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetCTS"), Value_Array)
        If R_Result = 0 Then
            'GetCTS = Trim(ByteToASCII(Value_Array))
            GetCTS = System.Text.Encoding.Default.GetString(Value_Array, 0, Value_Array.Length)
        End If
    End Function


    Public Function GetDSR() As String
        GetDSR = ""
        R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetDSR"), Value_Array)
        If R_Result = 0 Then
            GetDSR = Trim(ByteToASCII(Value_Array))
        End If
    End Function

    Public Function GetDCD() As String
        GetDCD = ""
        R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetDCD"), Value_Array)
        If R_Result = 0 Then
            GetDCD = Trim(ByteToASCII(Value_Array))
        End If
    End Function


    Public Sub OnRTSMessage(ByVal wParam As IntPtr, ByVal lParam As IntPtr)
        Dim m_bRTS As Boolean
        If (wParam = 1) Then
            If (lParam = 0) Then
                m_bRTS = False ' Power Down
            Else
                m_bRTS = True ' Power Up
            End If
        End If
    End Sub


    Public Sub OnCTSMessage(ByVal wParam As IntPtr, ByVal lParam As IntPtr)
        Dim m_bCTS As Boolean
        If (wParam = 1) Then
            If (lParam = 0) Then
                m_bCTS = False
            Else
                m_bCTS = True
            End If
        End If
    End Sub

    Public Sub OnConnect(ByVal wParam As IntPtr, ByVal lParam As IntPtr)
    End Sub

    Public Sub OnDisConnect(ByVal wParam As IntPtr, ByVal lParam As IntPtr)
    End Sub




    Public Function ASCIIToHex(ByVal Input As String) As String
        Dim i As Integer
        Dim dez1 As Integer
        Dim tmp As String
        Dim Result As String
        ASCIIToHex = ""
        For i = 1 To Len(Input)
            dez1 = Asc(Mid(Input, i, 2))
            tmp = Hex(dez1)
            ASCIIToHex &= tmp
        Next i
        Result = Trim(ASCIIToHex)
        Return Result
    End Function

    Public Function HexToASCII(ByVal Input As String) As String
        Dim i As Integer
        Dim dez1 As Integer
        Dim tmp As String
        HexToASCII = ""
        For i = 1 To Len(Input)
            dez1 = CInt("&H" & Mid(Input, i, 2))
            If Not Chr(dez1) = Nothing Then
                tmp = Chr(dez1)
                HexToASCII &= tmp
            End If
            i = i + 1
        Next
    End Function

    Public Function ByteToHex(ByVal src As Byte()) As String
        Dim i As Integer
        Dim tmp As String
        ByteToHex = ""
        For i = src.GetLowerBound(0) To src.GetUpperBound(0)
            tmp = ""
            tmp = Hex(src(i))
            If Len(tmp) = 1 Then
                tmp = "0" & tmp
            End If
            ByteToHex &= tmp
        Next i
    End Function

    Public Function ByteToASCII(ByVal Src As Byte()) As String
        Dim i As Integer
        Dim tmp As Char
        ByteToASCII = ""
        For i = Src.GetLowerBound(0) To Src.GetUpperBound(0)
            tmp = ""
            tmp = Chr(Src(i))
            ByteToASCII &= tmp
        Next i
        Return ByteToASCII
    End Function

    Public Sub ASCIIToByte(ByVal src As String, ByRef des As Byte())
        Dim i As Integer
        For i = 1 To Len(src)
            des(i - 1) = Asc(Mid(src, i, 1))
        Next i
    End Sub

    Public Function GetDynASCIIByte(ByVal src As String) As Byte()
        Dim i As Integer
        Dim des As Byte()
        GetDynASCIIByte = New Byte(src.Length - 1) {}
        des = New Byte(src.Length - 1) {}
        For i = 1 To Len(src)
            des(i - 1) = Asc(Mid(src, i, 1))
        Next
        GetDynASCIIByte = des
        Return GetDynASCIIByte
    End Function

    Public Function GetASCIIByte(ByVal src As String) As Byte()
        Dim i As Integer
        Dim des As Byte()
        GetASCIIByte = New Byte(255) {}
        des = New Byte(255) {}
        For i = 1 To Len(src)
            des(i - 1) = Asc(Mid(src, i, 1))
        Next
        GetASCIIByte = des
        Return GetASCIIByte
    End Function

    Public Function GetASCIIChar(ByVal src As String) As Char()
        Dim i As Integer
        Dim des As Char()
        GetASCIIChar = New Char(src.Length - 1) {}
        des = New Char(src.Length - 1) {}
        For i = 1 To Len(src)
            des(i - 1) = Mid(src, i, 1)
        Next
        GetASCIIChar = des
        Return GetASCIIChar
    End Function

    Public Function Initialize(ByVal Port As String) As Boolean
        Initialize = False
        IsActive = False
        iReaderHnd = -1
        iPortHnd = -1
        iReaderHnd = FEISC_NewReader(0)
        If iReaderHnd > 0 Then
            RaiseEvent GetReaderText("iReaderHnd = OK")
            My_ComArray(0) = Asc(Port)
            iPortHnd = FECOM_OpenPort(My_ComArray)
            If iPortHnd > 0 Then
                RaiseEvent GetReaderText("iPortHnd = OK")
                'R_Result = FEISC_SetReaderPara(iReaderHnd, GetASCIIByte("FrameSupport"), GetASCIIByte("Standart"))
                R_Result = FEISC_SetReaderPara(iReaderHnd, GetASCIIByte("PortHnd"), GetASCIIByte(iPortHnd.ToString))
                'R_Result = FEISC_SetReaderPara(iReaderHnd, GetASCIIByte("PortHnd"), GetASCIIByte("0"))
                'iSa = FEISC_SetReaderPara(iReaderHnd, "PortHnd", iPortHnd.ToString)
                R_Result = FEISC_SetReaderPara(iPortHnd, GetASCIIByte("PowerOnTime"), GetASCIIByte("10"))
                R_Result = FEISC_SetReaderPara(iPortHnd, GetASCIIByte("WaitAfterPowerOn"), GetASCIIByte("100"))
                R_Result = FECOM_SetPortPara(iPortHnd, GetASCIIByte("Baud"), GetASCIIByte(sBaud))
                R_Result = FECOM_SetPortPara(iPortHnd, GetASCIIByte("Frame"), GetASCIIByte(sFrame))
                R_Result = FECOM_SetPortPara(iPortHnd, GetASCIIByte("Timeout"), GetASCIIByte(sTimeout))
                R_Result = FECOM_SetPortPara(iPortHnd, GetASCIIByte("CharTimeoutMpy"), GetASCIIByte("9"))
                R_Result = FECOM_DoPortCmd(iPortHnd, GetASCIIByte("SetDTR"), GetASCIIByte("ON"))
                'R_Result = FECOM_DoPortCmd(iPortHnd, GetASCIIByte("SetRTS"), GetASCIIByte("ON"))
                'Initialize = CheckFeigVersion() = 0
                Initialize = True
            Else
                RaiseEvent GetReaderText("iPortHnd = ERROR")
            End If
        Else
            RaiseEvent GetReaderText("iReaderHnd = ERROR")
        End If
        IsActive = Initialize
        If Not IsActive Then
            ReaderUnload()
        Else
            SetOn()
        End If
        Return Initialize
    End Function

    Public Function NotCTS() As Boolean
        Dim tmp As String
        NotCTS = False
        FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetCTS"), Value_Array)
        tmp = System.Text.Encoding.Default.GetString(Value_Array, 0, Value_Array.Length)
        NotCTS = tmp Like "*OFF*"
        RaiseEvent IsReaderDown(NotCTS)
    End Function

    Public Function CheckReaderCTS() As Boolean
        Dim Result As Boolean
        Dim i As Integer
        LastCTS = False
        For i = 1 To 3
            System.Windows.Forms.Application.DoEvents()
            If NotCTS() Then
                SetOn()
                Result = False
            Else
                Result = True
            End If
            If Result Then
                Exit For
            End If
        Next i
        LastCTS = Result
        Return Result
    End Function

    Public Function SetOn() As Boolean
        Dim R1 As Boolean
        Dim R2 As Boolean
        SetOn = False
        R1 = FECOM_DoPortCmd(iPortHnd, GetASCIIByte("SetDTR"), GetASCIIByte("ON"))
        R2 = FECOM_DoPortCmd(iPortHnd, GetASCIIByte("SetRTS"), GetASCIIByte("ON"))
        SetOn = (R1 = True) And (R2 = True)
    End Function

    Public Function ReaderUnload() As Integer
        ReaderUnload = -1
        If iPortHnd > 0 Then
            R_Result = FECOM_DoPortCmd(iPortHnd, GetASCIIByte("SetRTS"), GetASCIIByte("OFF"))
            ReaderUnload = FECOM_ClosePort(iPortHnd)
        End If
        If iReaderHnd > 0 Then ReaderUnload = FEISC_DeleteReader(iReaderHnd)
        IsActive = False
        Return ReaderUnload
    End Function

    Public Function GetSoftwareVersionF() As Boolean
        SoftwareInfo = ""
        ClearArray(Read_Array)
        R_Result = FEISC_0x65_SoftVersion(iReaderHnd, cBusAdr, Read_Array, iDataType)
        GetErrorText(R_Result)
        SoftwareInfo = "Software Revision" & vbCrLf & _
                       "Hardware Type" & vbCrLf & _
                       "Reader Firmware" & vbCrLf & _
                       "Transponder Types"
        SoftwareInfo = ByteToHex(Read_Array)
        SoftwareInfo = SoftwareInfo.Substring(1, 16)
        Return R_Result = 0
    End Function

    Public Function GetReaderInfo(ByVal index As Integer) As Boolean
        Dim tmp As String
        Dim tmpint As Integer
        'SetOn()
        'Firmware Version of RF Communication Controller:
        'Software Revision:.....00-07-00
        'Hardware Type:.........= &HFE
        'Reader Type:...........93 (ID ISC.LRU2000)
        'Transponder Types:.....= &H00 = &H12
        'Max. Rx buffer size:...00280
        'Max. Tx buffer size:...00520
        '000700 FE 5D 001201180208000000
        IsUHF = False
        IsHF = False
        ClearStringArray(InfoReader)
        R_Result = FEISC_0x66_ReaderInfo(iReaderHnd, cBusAdr, index, Read_Array, iDataType)
        GetErrorText(R_Result)
        If R_Result = 0 Then
            tmp = ByteToHex(Read_Array)
            InfoReader(0) = "Software Revision:" & tmp.Substring(0, 6)
            InfoReader(1) = "Hardware Type:= 0x" & tmp.Substring(6, 2)
            tmpint = CInt("&H" & tmp.Substring(8, 2))
            InfoReader(2) = "Reader Type:" & tmpint.ToString & "/" & GetReaderTyp(tmpint) '5D / 93
            InfoReader(3) = "Transponder Types:" & tmp.Substring(10, 4) '0012
            IsUHF = InfoReader(2) Like "*ISCUM02*"
            IsHF = InfoReader(2) Like "*CPR.M02*"
        End If
        Return R_Result = 0
    End Function

    Private Function CheckFeigVersion() As Integer
        CheckFeigVersion = 0
        COMVersion = GetCOMDLLVersion()
        ISCVersion = GetISCDLLVersion()
        ClearArray(Read_Array)
        'RaiseEvent GetReaderText("CheckFeigVersion")
        'R_Result = FEISC_= &H66_ReaderInfo(iReaderHnd, cBusAdr, 1, Read_Array, iDataType)
        'GetErrorText(R_Result)
        CheckFeigVersion = 0
        ReaderInfo = ByteToASCII(Read_Array)
        Return CheckFeigVersion
    End Function


    Public Function GetCOMDLLVersion() As String
        GetCOMDLLVersion = ""
        'GetDLLVersion = New String(" ", 256)
        RaiseEvent GetReaderText("GetCOMDLLVersion")
        FECOM_GetDLLVersion(Read_Array)
        GetCOMDLLVersion = ByteToASCII(Read_Array)
        Return GetCOMDLLVersion
    End Function

    Public Function GetISCDLLVersion() As String
        GetISCDLLVersion = ""
        'GetDLLVersion = New String(" ", 256)
        RaiseEvent GetReaderText("GetISCDLLVersion")
        FEISC_GetDLLVersion(Read_Array)
        GetISCDLLVersion = ByteToASCII(Read_Array)
        Return GetISCDLLVersion
    End Function

    Public Function WriteTagBlock(ByVal BNr As Integer, ByVal Blaenge As Integer, ByVal Data As String, ByVal Index As Integer) As Boolean
        Dim Result As Boolean = False
        Dim tmpData As String
        Dim erg As Integer
        Dim i As Integer
        'SetOn()
        erg = 16 + ((Blaenge - 1) * 4)
        Write_Array = New Byte(erg) {}
        Write_Array(0) = 36
        Write_Array(1) = 1
        Write_Array(2) = CInt("&H" & UIDNr(0) & UIDNr(1))
        Write_Array(3) = CInt("&H" & UIDNr(2) & UIDNr(3))
        Write_Array(4) = CInt("&H" & UIDNr(4) & UIDNr(5))
        Write_Array(5) = CInt("&H" & UIDNr(6) & UIDNr(7))
        Write_Array(6) = CInt("&H" & UIDNr(8) & UIDNr(9))
        Write_Array(7) = CInt("&H" & UIDNr(10) & UIDNr(11))
        Write_Array(8) = CInt("&H" & UIDNr(12) & UIDNr(13))
        Write_Array(9) = CInt("&H" & UIDNr(14) & UIDNr(15))
        Write_Array(10) = BNr
        Write_Array(11) = Blaenge
        Write_Array(12) = 4
        For i = Data.Length To Blaenge * 4 - 1
            Data += " "
        Next

        If Index = 1 Then
            tmpData = Data.Substring(4, 4) & Data.Substring(0, 4)
            Data = tmpData
        End If
        If Index = 2 Then
            If Blaenge = 8 Then
                tmpData = Data.Substring(28, 4) & Data.Substring(24, 4) & _
                          Data.Substring(20, 4) & Data.Substring(16, 4) & _
                          Data.Substring(12, 4) & Data.Substring(8, 4) & _
                          Data.Substring(4, 4) & Data.Substring(0, 4)
                Data = tmpData
            End If
            If Blaenge = 32 Then
                tmpData = Data.Substring(124, 4) & Data.Substring(120, 4) & _
                          Data.Substring(116, 4) & Data.Substring(112, 4) & _
                          Data.Substring(108, 4) & Data.Substring(104, 4) & _
                          Data.Substring(100, 4) & Data.Substring(96, 4) & _
                          Data.Substring(92, 4) & Data.Substring(88, 4) & _
                          Data.Substring(84, 4) & Data.Substring(80, 4) & _
                          Data.Substring(76, 4) & Data.Substring(72, 4) & _
                          Data.Substring(68, 4) & Data.Substring(64, 4) & _
                          Data.Substring(60, 4) & Data.Substring(56, 4) & _
                          Data.Substring(52, 4) & Data.Substring(48, 4) & _
                          Data.Substring(44, 4) & Data.Substring(40, 4) & _
                          Data.Substring(36, 4) & Data.Substring(32, 4) & _
                          Data.Substring(28, 4) & Data.Substring(24, 4) & _
                          Data.Substring(20, 4) & Data.Substring(16, 4) & _
                          Data.Substring(12, 4) & Data.Substring(8, 4) & _
                          Data.Substring(4, 4) & Data.Substring(0, 4)
                Data = tmpData
            End If
        End If

        For i = 13 To erg
            Write_Array(i) = Asc(Data(i - 13))
        Next

        R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, Write_Array, Write_Array.Length, cRspData, iRspLen, iDataType)
        GetErrorText(R_Result)

        Result = R_Result = 0
        Return Result
    End Function

    Public Function WriteTagBlock24(ByVal BNr As Integer, ByVal Blaenge As Integer, ByVal Data As String, ByVal Index As Integer) As Boolean
        Dim Result As Boolean = False
        Dim tmpData As String
        Dim erg As Integer
        Dim i As Integer
        'SetOn()
        If UIDNr.Length <> 24 Then Exit Function

        erg = 20 + (Blaenge * 2) - 1
        Write_Array = New Byte(erg) {}




        Write_Array(0) = 36
        Write_Array(1) = 49
        Write_Array(2) = 12

        Write_Array(3) = CInt("&H" & UIDNr(0) & UIDNr(1))
        Write_Array(4) = CInt("&H" & UIDNr(2) & UIDNr(3))
        Write_Array(5) = CInt("&H" & UIDNr(4) & UIDNr(5))
        Write_Array(6) = CInt("&H" & UIDNr(6) & UIDNr(7))
        Write_Array(7) = CInt("&H" & UIDNr(8) & UIDNr(9))
        Write_Array(8) = CInt("&H" & UIDNr(10) & UIDNr(11))
        Write_Array(9) = CInt("&H" & UIDNr(12) & UIDNr(13))
        Write_Array(10) = CInt("&H" & UIDNr(14) & UIDNr(15))
        Write_Array(11) = CInt("&H" & UIDNr(16) & UIDNr(17))
        Write_Array(12) = CInt("&H" & UIDNr(18) & UIDNr(19))
        Write_Array(13) = CInt("&H" & UIDNr(20) & UIDNr(21))
        Write_Array(14) = CInt("&H" & UIDNr(22) & UIDNr(23))

        Write_Array(15) = 3
        Write_Array(16) = 0
        Write_Array(17) = BNr  '      // Address
        Write_Array(18) = Blaenge '  // Number of Block
        Write_Array(19) = 2     '      //   Block Size


        For i = Data.Length To Blaenge * 2 - 1
            Data += " "
        Next

        If Index = 1 Then
            tmpData = Data.Substring(4, 2) & Data.Substring(0, 2)
            Data = tmpData
        End If
        If Index = 2 Then
            If Blaenge = 8 Then
                tmpData = Data.Substring(28, 4) & Data.Substring(24, 4) & _
                          Data.Substring(20, 4) & Data.Substring(16, 4) & _
                          Data.Substring(12, 4) & Data.Substring(8, 4) & _
                          Data.Substring(4, 4) & Data.Substring(0, 4)
                Data = tmpData
            End If
            If Blaenge = 32 Then
                tmpData = Data.Substring(124, 4) & Data.Substring(120, 4) & _
                          Data.Substring(116, 4) & Data.Substring(112, 4) & _
                          Data.Substring(108, 4) & Data.Substring(104, 4) & _
                          Data.Substring(100, 4) & Data.Substring(96, 4) & _
                          Data.Substring(92, 4) & Data.Substring(88, 4) & _
                          Data.Substring(84, 4) & Data.Substring(80, 4) & _
                          Data.Substring(76, 4) & Data.Substring(72, 4) & _
                          Data.Substring(68, 4) & Data.Substring(64, 4) & _
                          Data.Substring(60, 4) & Data.Substring(56, 4) & _
                          Data.Substring(52, 4) & Data.Substring(48, 4) & _
                          Data.Substring(44, 4) & Data.Substring(40, 4) & _
                          Data.Substring(36, 4) & Data.Substring(32, 4) & _
                          Data.Substring(28, 4) & Data.Substring(24, 4) & _
                          Data.Substring(20, 4) & Data.Substring(16, 4) & _
                          Data.Substring(12, 4) & Data.Substring(8, 4) & _
                          Data.Substring(4, 4) & Data.Substring(0, 4)
                Data = tmpData
            End If
        End If

        For i = 20 To erg
            Write_Array(i) = Asc(Data(i - 20))
        Next

        R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, Write_Array, Write_Array.Length, cRspData, iRspLen, iDataType)
        GetErrorText(R_Result)

        Result = R_Result = 0
        Return Result
    End Function

    Public Function ReadTagBlock24(ByVal BNr As Integer, ByVal BLaenge As Integer, ByVal Index As Integer) As Boolean
        Dim Result As Boolean = False
        Dim i As Integer
        Dim BStart As Integer = 3
        Dim BStop As Integer = 4
        Dim tmpData As String

        '05000000000000000001E0C9
        'B0 23 11   0C (lngenflag)   05 00 00 00 00 00 00 00 00 01 E0 C9     02 06 Adress+Blocklnge
        '09/07/09 15:49:39.500  >>  02 00 18 FF B0 23 11 0C 05 00 00 00 00 00 00 00 00 01 E0 C9 02 06 3C E4
        '09/07/09 15:49:39.593  <<  02 00 1C 00 B0 00 06 02 00 05 00 00 00 00 00 00 00 00 00 00 00 00 01 00 E0 C9 0B 8C   OK
        '09/08/09 11:22:02.000  >>  02 00 1A FF B0 23 31 0C 05 00 00 00 00 00 00 00 00 01 E0 C9  03  00  08 05  83 52
        '09/08/09 11:22:02.109  <<  02 00 19 00 B0 00 05 02 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 6C A3   OK

        'UIDBlock[0] := 35;  // Hex 23
        'UIDBlock[1] := 49; // Hex 31
        'UIDBlock[2] := 12;  // Hex 0C lngen-flag
        'UIDBlock[3]  := StrToInt('$'+ UID[1] + UID[2]);        // 1
        'UIDBlock[4]  := StrToInt('$'+ UID[3] + UID[4]);        // 2
        'UIDBlock[5]  := StrToInt('$'+ UID[5] + UID[6]);        // 3
        'UIDBlock[6]  := StrToInt('$'+ UID[7] + UID[8]);        // 4
        'UIDBlock[7]  := StrToInt('$'+ UID[9] + UID[10]);       // 5
        'UIDBlock[8]  := StrToInt('$'+ UID[11] + UID[12]);      // 6
        'UIDBlock[9]  := StrToInt('$'+ UID[13] + UID[14]);      // 7
        'UIDBlock[10]  := StrToInt('$'+ UID[15] + UID[16]);     // 8
        'UIDBlock[11] := StrToInt('$'+ UID[17] + UID[18]);      // 9
        'UIDBlock[12] := StrToInt('$'+ UID[19] + UID[20]);      // 10
        'UIDBlock[13] := StrToInt('$'+ UID[21] + UID[22]);      // 11
        'UIDBlock[14] := StrToInt('$'+ UID[23] + UID[24]);      // 12
        'UIDBlock[15] := 03;
        'UIDBlock[16] := 00;
        'UIDBlock[17] := BNr;
        'UIDBlock[18] := BLaenge;


        BlockDataHex = ""
        'SetOn()
        cRspData = New Byte(511) {}
        R_Result = -1
        If UIDNr.Length <> 24 Then Exit Function
        UID_Array24(0) = 35
        UID_Array24(1) = 49
        UID_Array24(2) = 12

        UID_Array24(3) = CInt("&H" & UIDNr(0) & UIDNr(1))
        UID_Array24(4) = CInt("&H" & UIDNr(2) & UIDNr(3))
        UID_Array24(5) = CInt("&H" & UIDNr(4) & UIDNr(5))
        UID_Array24(6) = CInt("&H" & UIDNr(6) & UIDNr(7))
        UID_Array24(7) = CInt("&H" & UIDNr(8) & UIDNr(9))
        UID_Array24(8) = CInt("&H" & UIDNr(10) & UIDNr(11))
        UID_Array24(9) = CInt("&H" & UIDNr(12) & UIDNr(13))
        UID_Array24(10) = CInt("&H" & UIDNr(14) & UIDNr(15))
        UID_Array24(11) = CInt("&H" & UIDNr(16) & UIDNr(17))
        UID_Array24(12) = CInt("&H" & UIDNr(18) & UIDNr(19))
        UID_Array24(13) = CInt("&H" & UIDNr(20) & UIDNr(21))
        UID_Array24(14) = CInt("&H" & UIDNr(22) & UIDNr(23))
        UID_Array24(15) = 3
        UID_Array24(16) = 0
        UID_Array24(17) = BNr
        '    UIDBlock24[11] :=   '02; 2 Blcke, 08 = 8 Blcke
        UID_Array24(18) = BLaenge
        iRspLen = 0
        R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, UID_Array24, 19, cRspData, iRspLen, iDataType)
        GetErrorText(R_Result)
        If R_Result = 0 Then
            If iRspLen > 0 Then
                If Index = 0 Or Index = 1 Then
                    For i = 1 To cRspData(0)
                        If Index = 0 Then BlockDataHex = BlockDataHex + GetByteDataBufferToHex(cRspData, BStart, BStop)
                        If Index = 1 Then BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, BStop) + BlockDataHex
                        BStart = BStart + 3
                        BStop = BStop + 3
                    Next
                    BlockDataAScII = HexToASCII(BlockDataHex)
                End If
                If Index = 2 And BLaenge = 8 Then
                    BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, iRspLen - 1)
                    tmpData = BlockDataHex.Substring(70, 8) & BlockDataHex.Substring(60, 8) & _
                      BlockDataHex.Substring(50, 8) & BlockDataHex.Substring(40, 8) & _
                      BlockDataHex.Substring(30, 8) & BlockDataHex.Substring(20, 8) & _
                      BlockDataHex.Substring(10, 8) & BlockDataHex.Substring(0, 8)
                    BlockDataAScII = HexToASCII(tmpData)
                End If
                If Index = 2 And BLaenge = 32 Then
                    BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, iRspLen - 1)
                    tmpData = BlockDataHex.Substring(310, 8) & BlockDataHex.Substring(300, 8) & _
                      BlockDataHex.Substring(290, 8) & BlockDataHex.Substring(280, 8) & _
                      BlockDataHex.Substring(270, 8) & BlockDataHex.Substring(260, 8) & _
                      BlockDataHex.Substring(250, 8) & BlockDataHex.Substring(240, 8) & _
                      BlockDataHex.Substring(230, 8) & BlockDataHex.Substring(220, 8) & _
                      BlockDataHex.Substring(210, 8) & BlockDataHex.Substring(200, 8) & _
                      BlockDataHex.Substring(190, 8) & BlockDataHex.Substring(180, 8) & _
                      BlockDataHex.Substring(170, 8) & BlockDataHex.Substring(160, 8) & _
                      BlockDataHex.Substring(150, 8) & BlockDataHex.Substring(140, 8) & _
                      BlockDataHex.Substring(130, 8) & BlockDataHex.Substring(120, 8) & _
                      BlockDataHex.Substring(110, 8) & BlockDataHex.Substring(100, 8) & _
                      BlockDataHex.Substring(90, 8) & BlockDataHex.Substring(80, 8) & _
                      BlockDataHex.Substring(70, 8) & BlockDataHex.Substring(60, 8) & _
                      BlockDataHex.Substring(50, 8) & BlockDataHex.Substring(40, 8) & _
                      BlockDataHex.Substring(30, 8) & BlockDataHex.Substring(20, 8) & _
                      BlockDataHex.Substring(10, 8) & BlockDataHex.Substring(0, 8)
                    BlockDataAScII = HexToASCII(tmpData)
                End If

            End If
        End If
        Result = R_Result = 0
        Return Result
    End Function

    Public Function ReadMifare(ByVal BNr As Integer, ByVal BLaenge As Integer, ByVal Index As Integer) As Boolean
        Dim Result As Boolean = False
        Dim i As Integer
        Dim BStart As Integer = 3
        Dim BStop As Integer = 18
        Dim tmpData As String
        BlockDataHex = ""
        'SetOn()
        cRspData = New Byte(511) {}
        R_Result = -1

        '09 FF B0 23 02 00 04 1A C8
        ReadMi_Array(0) = 35   ' hex 23 = DataBlock   ' hex 0A = ConfigBlock (geht nicht)
        ReadMi_Array(1) = 2    ' Mode Addressed selected, ist immer 2
        ReadMi_Array(2) = BNr
        ReadMi_Array(3) = BLaenge
        iReqLen = ReadMi_Array.Length
        iRspLen = cRspData.Length
        'SetOn()
        iRspLen = 0
        R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, ReadMi_Array, iReqLen, cRspData, iRspLen, iDataType)
        GetErrorText(R_Result)
        If R_Result = 0 Then
            If iRspLen > 0 Then
                If Index = 0 Or Index = 1 Then
                    For i = 1 To cRspData(0)
                        If Index = 0 Then BlockDataHex = BlockDataHex + GetByteDataBufferToHexInverted(cRspData, BStart, BStop)
                        If Index = 1 Then BlockDataHex = GetByteDataBufferToHexInverted(cRspData, BStart, BStop) + BlockDataHex
                        BStart = BStart + 5
                        BStop = BStop + 5
                    Next
                    BlockDataAScII = HexToASCII(BlockDataHex)
                End If
            End If
        End If
        Result = R_Result = 0
        Return Result
    End Function


    Public Function WriteMifare(ByVal BNr As Integer, ByVal BLaenge As Integer, ByVal Data As String, ByVal Index As Integer) As Boolean
        Dim Result As Boolean = False
        Dim i As Integer
        Dim erg As Integer
        Dim BStart As Integer = 3
        Dim BStop As Integer = 18
        Dim tmpData As String
        BlockDataHex = ""
        'SetOn()
        cRspData = New Byte(511) {}
        R_Result = -1

        '1A FF B0 24 02  01 01  10  00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 69 27 
        '2A FF B0 24 02  02 02  10  00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 14 77 

        '09 FF B0 23 02 00 04 1A C8
        erg = 5 + (BLaenge * 16) - 1
        WriteMi_Array = New Byte(erg) {}


        WriteMi_Array(0) = 36   ' hex 24 = DataBlock 
        WriteMi_Array(1) = 2 ' Mode Addressed selected, ist immer 2
        WriteMi_Array(2) = BNr
        WriteMi_Array(3) = BLaenge
        WriteMi_Array(4) = 16 'Block-Size, ist fix



        For i = Data.Length To BLaenge * 16 - 1
            Data += " "
        Next

        Data = GetInverted(Data)

        For i = 5 To erg
            WriteMi_Array(i) = Asc(Data(i - 5))
        Next

        iReqLen = WriteMi_Array.Length
        iRspLen = cRspData.Length
        'SetOn()
        iRspLen = 0
        R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, WriteMi_Array, iReqLen, cRspData, iRspLen, iDataType)
        GetErrorText(R_Result)

        Result = R_Result = 0
        Return Result
    End Function

    Public Function ReadTagBlock(ByVal BNr As Integer, ByVal BLaenge As Integer, ByVal Index As Integer) As Boolean
        Dim Result As Boolean = False
        Dim i As Integer
        Dim BStart As Integer = 3
        Dim BStop As Integer = 6
        Dim tmpData As String
        BlockDataHex = ""
        'SetOn()
        cRspData = New Byte(511) {}
        R_Result = -1
        If UIDNr.Length <> 16 Then Exit Function
        UID_Array(0) = 35
        UID_Array(1) = 1
        UID_Array(2) = CInt("&H" & UIDNr(0) & UIDNr(1))
        UID_Array(3) = CInt("&H" & UIDNr(2) & UIDNr(3))
        UID_Array(4) = CInt("&H" & UIDNr(4) & UIDNr(5))
        UID_Array(5) = CInt("&H" & UIDNr(6) & UIDNr(7))
        UID_Array(6) = CInt("&H" & UIDNr(8) & UIDNr(9))
        UID_Array(7) = CInt("&H" & UIDNr(10) & UIDNr(11))
        UID_Array(8) = CInt("&H" & UIDNr(12) & UIDNr(13))
        UID_Array(9) = CInt("&H" & UIDNr(14) & UIDNr(15))

        UID_Array(10) = BNr
        '    UIDBlock[11] :=   '02; 2 Blcke, 08 = 8 Blcke
        UID_Array(11) = BLaenge
        iRspLen = 0
        R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, UID_Array, 12, cRspData, iRspLen, iDataType)
        GetErrorText(R_Result)
        If R_Result = 0 Then
            If iRspLen > 0 Then
                If Index = 0 Or Index = 1 Then
                    For i = 1 To cRspData(0)
                        If Index = 0 Then BlockDataHex = BlockDataHex + GetByteDataBufferToHex(cRspData, BStart, BStop)
                        If Index = 1 Then BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, BStop) + BlockDataHex
                        BStart = BStart + 5
                        BStop = BStop + 5
                    Next
                    BlockDataAScII = HexToASCII(BlockDataHex)
                End If
                If Index = 2 And BLaenge = 8 Then
                    BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, iRspLen - 1)
                    tmpData = BlockDataHex.Substring(70, 8) & BlockDataHex.Substring(60, 8) & _
                      BlockDataHex.Substring(50, 8) & BlockDataHex.Substring(40, 8) & _
                      BlockDataHex.Substring(30, 8) & BlockDataHex.Substring(20, 8) & _
                      BlockDataHex.Substring(10, 8) & BlockDataHex.Substring(0, 8)
                    BlockDataAScII = HexToASCII(tmpData)
                End If
                If Index = 2 And BLaenge = 32 Then
                    BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, iRspLen - 1)
                    tmpData = BlockDataHex.Substring(310, 8) & BlockDataHex.Substring(300, 8) & _
                      BlockDataHex.Substring(290, 8) & BlockDataHex.Substring(280, 8) & _
                      BlockDataHex.Substring(270, 8) & BlockDataHex.Substring(260, 8) & _
                      BlockDataHex.Substring(250, 8) & BlockDataHex.Substring(240, 8) & _
                      BlockDataHex.Substring(230, 8) & BlockDataHex.Substring(220, 8) & _
                      BlockDataHex.Substring(210, 8) & BlockDataHex.Substring(200, 8) & _
                      BlockDataHex.Substring(190, 8) & BlockDataHex.Substring(180, 8) & _
                      BlockDataHex.Substring(170, 8) & BlockDataHex.Substring(160, 8) & _
                      BlockDataHex.Substring(150, 8) & BlockDataHex.Substring(140, 8) & _
                      BlockDataHex.Substring(130, 8) & BlockDataHex.Substring(120, 8) & _
                      BlockDataHex.Substring(110, 8) & BlockDataHex.Substring(100, 8) & _
                      BlockDataHex.Substring(90, 8) & BlockDataHex.Substring(80, 8) & _
                      BlockDataHex.Substring(70, 8) & BlockDataHex.Substring(60, 8) & _
                      BlockDataHex.Substring(50, 8) & BlockDataHex.Substring(40, 8) & _
                      BlockDataHex.Substring(30, 8) & BlockDataHex.Substring(20, 8) & _
                      BlockDataHex.Substring(10, 8) & BlockDataHex.Substring(0, 8)
                    BlockDataAScII = HexToASCII(tmpData)
                End If

            End If
        End If
        Result = R_Result = 0
        Return Result
    End Function

    Public Function SelectMifare() As Boolean
        Dim tmpE As String
        Dim i As Integer
        SelectMifare = False
        'R_Result = FEISC_0x69_RFReset(iReaderHnd, cBusAdr)

        'cReqData(0) = 1  '01 00
        'cReqData(1) = 0
        'iReqLen = cReqData.Length
        'iRspLen = cRspData.Length
        tmpE = UIDNr
        For i = UIDNr.Length To 16 - 1
            tmpE = "0" & tmpE
        Next

        SelMifare_Array(0) = 37
        SelMifare_Array(1) = 1

        SelMifare_Array(2) = CInt("&H" & tmpE(0) & tmpE(1))
        SelMifare_Array(3) = CInt("&H" & tmpE(2) & tmpE(3))
        SelMifare_Array(4) = CInt("&H" & tmpE(4) & tmpE(5))
        SelMifare_Array(5) = CInt("&H" & tmpE(6) & tmpE(7))
        SelMifare_Array(6) = CInt("&H" & tmpE(8) & tmpE(9))
        SelMifare_Array(7) = CInt("&H" & tmpE(10) & tmpE(11))
        SelMifare_Array(8) = CInt("&H" & tmpE(12) & tmpE(13))
        SelMifare_Array(9) = CInt("&H" & tmpE(14) & tmpE(15))

        iReqLen = SelMifare_Array.Length
        iRspLen = cRspData.Length


        'SetOn()
        ' B0 25 01 00 00 00 00 A6 8A B4 B6 26 2D 
        ' iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef cRspData As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
        R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, SelMifare_Array, iReqLen, cRspData, iRspLen, iDataType)
        GetErrorText(R_Result)
        SelectMifare = R_Result = 0
        Return SelectMifare
    End Function

    Public Function SetKeyMifare(ByVal Block As Integer) As Boolean
        Dim tmpE As String
        SetKeyMifare = False
        'R_Result = FEISC_0x69_RFReset(iReaderHnd, cBusAdr)

        'cReqData(0) = 1  '01 00
        'cReqData(1) = 0
        'iReqLen = cReqData.Length
        'iRspLen = cRspData.Length
        Key_Array(0) = 176
        Key_Array(1) = 10

        Key_Array(2) = Block  ' DB Adresse
        Key_Array(3) = 0  ' Key A = 0, Key B = 1

        If MifareKey.Length = 12 Then
            Key_Array(4) = CInt("&H" & MifareKey(0) & MifareKey(1)) 'MifareKey
            Key_Array(5) = CInt("&H" & MifareKey(0) & MifareKey(1)) 'MifareKey
            Key_Array(6) = CInt("&H" & MifareKey(0) & MifareKey(1)) 'MifareKey
            Key_Array(7) = CInt("&H" & MifareKey(0) & MifareKey(1)) 'MifareKey
            Key_Array(8) = CInt("&H" & MifareKey(0) & MifareKey(1)) 'MifareKey
            Key_Array(9) = CInt("&H" & MifareKey(0) & MifareKey(1)) 'MifareKey
        Else
            Key_Array(4) = 0 'MifareKey
            Key_Array(5) = 0 'MifareKey
            Key_Array(6) = 0 'MifareKey
            Key_Array(7) = 0 'MifareKey
            Key_Array(8) = 0 'MifareKey
            Key_Array(9) = 0 'MifareKey
        End If

        iReqLen = Key_Array.Length
        iRspLen = cRspData.Length


        'SetOn()
        'FEISC_0xB2_ISOCmd(ByVal
        ' B0 0A 00 00 FF FF FF FF FF FF 
        ' iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef cRspData As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
        '00 00 FF FF FF FF FF FF 
        R_Result = FEISC_0xB2_ISOCmd(iReaderHnd, cBusAdr, Key_Array, iReqLen, cRspData, iRspLen, iDataType)
        GetErrorText(R_Result)
        SetKeyMifare = R_Result = 0
        Return SetKeyMifare
    End Function

    Public Function GetUID() As Boolean
        GetUID = False
        R_Result = FEISC_0x69_RFReset(iReaderHnd, cBusAdr)
        UIDNr = ""
        cReqData(0) = 1  '01 00
        cReqData(1) = 0
        iReqLen = cReqData.Length
        iRspLen = cRspData.Length
        'SetOn()
        If R_Result = 0 Then
            R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, cReqData, iReqLen, cRspData, iRspLen, iDataType)
            GetErrorText(R_Result)
            If R_Result = 0 Then
                If iRspLen > 0 Then
                    UIDNr = GetByteBufferToHex(cRspData, iRspLen)
                    UIDNr = CheckTAGData(UIDNr)
                End If
            End If
        Else
            GetErrorText(R_Result)
        End If
        GetUID = R_Result = 0
        Return GetUID
    End Function

    Private Function CheckTAGData(ByVal Data As String) As String
        Dim Tags As Integer
        Dim tmp As String
        'Dim uTagTyp As String
        Dim uTagNr As String = ""
        TagTyp = ""
        CheckTAGData = ""
        If Data.Length < 22 Then Exit Function
        Tags = CInt(Mid(Data, 1, 2))
        Data = Mid(Data, 3, Data.Length - 2)
        If Tags = 1 Then
            tmp = Mid(Data, 1, 2)
            TagTyp = GetTransponderTyp(CInt(tmp))
            'If tmp = "80" Then
            'TagTyp = "18000-6-A"
            'ElseIf tmp = "81" Then
            '   TagTyp = "18000-6-B "
            'ElseIf tmp = "83" Then
            'TagTyp = "EM4222"
            'ElseIf tmp = "84" Then
            'TagTyp = "EPC Gen 2"
            'ElseIf tmp = "89" Then
            'TagTyp = "EPC Class 1"
            'ElseIf tmp = "03" Then
            'TagTyp = "ISO 15693"
            'ElseIf tmp = "06" Then
            'TagTyp = "I-Code EPC"
            'ElseIf tmp = "07" Then
            'TagTyp = "I-Code UID"
            'Else : TagTyp = "UHF (unknown)"
            'End If
            If tmp = "03" Then
                uTagNr = Mid(Data, 5, 24)
            Else
                uTagNr = Mid(Data, 11, 24)
            End If
        End If
        Return uTagNr
    End Function

    Public Function SetISOMode(ByVal index As Integer) As Integer
        Config_Array(0) = 0
        Config_Array(1) = 0
        Config_Array(2) = 8
        Config_Array(3) = 1
        Config_Array(4) = 0
        Config_Array(5) = 0
        Config_Array(6) = 0
        Config_Array(7) = 30  ' 1E
        Config_Array(8) = 0
        Config_Array(9) = 0
        Config_Array(10) = 0
        Config_Array(11) = 0
        Config_Array(12) = 0
        Config_Array(13) = index  '  0 = ISOHost 1 = ISOScan
        R_Result = FEISC_0x81_WriteConfBlock(iReaderHnd, 255, 129, Config_Array, iDataType)
        GetErrorText(R_Result)
        If R_Result = 0 Then
            R_Result = FEISC_0x82_SaveConfBlock(iReaderHnd, 255, 1)
            GetErrorText(R_Result)
        End If
        Return R_Result
    End Function


    Public Sub New()
        Read_Array = New Byte(255) {}
        Write_Array = New Byte(255) {}
        My_ComArray = New Byte(3) {}
        Config_Array = New Byte(13) {}
        cReqData = New Byte(1) {}
        cRspData = New Byte(511) {}
        Info_Array = New Byte(511) {}
        UID_Array = New Byte(11) {}
        UID_Array24 = New Byte(18) {}
        Key_Array = New Byte(9) {}
        SelMifare_Array = New Byte(9) {}
        Value_Array = New Byte(16) {}
        InfoReader = New String(5) {}
        ReadMi_Array = New Byte(3) {}
        WriteMi_Array = New Byte(21) {}
    End Sub

    Protected Overrides Sub Finalize()
        ReaderUnload()
        MyBase.Finalize()
    End Sub


    Public Function GetTransponderTyp(ByVal iStatus As Integer) As String
        Dim result As String
        ' Wurde umgebaut..weil die werte in Hex sind
        Dim htmp As Integer
        Try
            htmp = CInt("&H" + iStatus.ToString)
        Catch ex As Exception
            htmp = -1
        End Try
        Select Case htmp
            Case FEDM_ISC_TR_TYPE_ICODE1
                result = FEDM_ISC_TR_NAME_ICODE1
            Case FEDM_ISC_TR_TYPE_TAGIT
                result = FEDM_ISC_TR_NAME_TAGIT
            Case FEDM_ISC_TR_TYPE_ISO15693
                result = FEDM_ISC_TR_NAME_ISO15693
            Case FEDM_ISC_TR_TYPE_ISO14443A
                result = FEDM_ISC_TR_NAME_ISO14443A
            Case FEDM_ISC_TR_TYPE_ISO14443B
                result = FEDM_ISC_TR_NAME_ISO14443B
            Case FEDM_ISC_TR_TYPE_EPC
                result = FEDM_ISC_TR_NAME_EPC
            Case FEDM_ISC_TR_TYPE_ICODE_UID
                result = FEDM_ISC_TR_NAME_ICODE_UID
            Case FEDM_ISC_TR_TYPE_JEWEL
                result = FEDM_ISC_TR_NAME_JEWEL
            Case FEDM_ISC_TR_TYPE_0x64
                result = FEDM_ISC_TR_NAME_0x64
                ' UHF transponder types
            Case FEDM_ISC_TR_TYPE_ISO18000_6_A
                result = FEDM_ISC_TR_NAME_ISO18000_6_A
            Case FEDM_ISC_TR_TYPE_ISO18000_6_B
                result = FEDM_ISC_TR_NAME_ISO18000_6_B
            Case FEDM_ISC_TR_TYPE_EM4222
                result = FEDM_ISC_TR_NAME_EM4222
            Case FEDM_ISC_TR_TYPE_EPC_CLASS1_GEN2
                result = FEDM_ISC_TR_NAME_EPC_CLASS1_GEN2
            Case FEDM_ISC_TR_TYPE_EPC_CLASS0
                result = FEDM_ISC_TR_NAME_EPC_CLASS0
            Case FEDM_ISC_TR_TYPE_EPC_CLASS1_GEN1
                result = FEDM_ISC_TR_NAME_EPC_CLASS1_GEN1
            Case FEDM_ISC_TR_TYPE_EPC_GEN2_HF
                result = FEDM_ISC_TR_NAME_EPC_GEN2_HF
            Case FEDM_ISC_TR_TYPE_STM_SR176
                result = FEDM_ISC_TR_NAME_STM_SR176
            Case FEDM_ISC_TR_TYPE_STM_SRIxx
                result = FEDM_ISC_TR_NAME_STM_SRIxx
            Case FEDM_ISC_TR_TYPE_MCRF45x
                result = FEDM_ISC_TR_NAME_MCRF45x
            Case FEDM_ISC_TR_TYPE_0x64
                result = FEDM_ISC_TR_NAME_0x64
            Case Else
                result = "unbekannter Typ"
        End Select
        Return result
    End Function

    Public Function GetReaderTyp(ByVal istatus As Integer) As String
        Dim Result As String
        Select Case istatus
            Case FEDM_ISC_TYPE_ISCPRHD102_X
                Result = FEDM_ISC_NAME_ISCPRHD102_X
            Case FEDM_ISC_TYPE_ISCM01
                Result = FEDM_ISC_NAME_ISCM01
            Case FEDM_ISC_TYPE_ISCM02
                Result = FEDM_ISC_NAME_ISCM02
            Case FEDM_ISC_TYPE_ISCLR100
                Result = FEDM_ISC_NAME_ISCLR100
            Case FEDM_ISC_TYPE_ISCLR200
                Result = FEDM_ISC_NAME_ISCLR200
            Case FEDM_ISC_TYPE_ISCLR2000
                Result = FEDM_ISC_NAME_ISCLR2000
            Case FEDM_ISC_TYPE_ISCPRH101
                Result = FEDM_ISC_NAME_ISCPRH101
            Case FEDM_ISC_TYPE_ISCPRH101_U
                Result = FEDM_ISC_NAME_ISCPRH101_U
            Case FEDM_ISC_TYPE_ISCPRH100_U
                Result = FEDM_ISC_NAME_ISCPRH100_U
            Case FEDM_ISC_TYPE_ISCPRH100
                Result = FEDM_ISC_NAME_ISCPRH100
            Case FEDM_ISC_TYPE_ISCMR100_U
                Result = FEDM_ISC_NAME_ISCMR100_U
            Case FEDM_ISC_TYPE_ISCMR100
                Result = FEDM_ISC_NAME_ISCMR100
            Case FEDM_ISC_TYPE_ISCPR100
                Result = FEDM_ISC_NAME_ISCPR100
            Case FEDM_ISC_TYPE_ISCMR200
                Result = FEDM_ISC_NAME_ISCMR200
            Case FEDM_ISC_TYPE_ISCMR101
                Result = FEDM_ISC_NAME_ISCMR101
            Case FEDM_ISC_TYPE_ISCMR101_U
                Result = FEDM_ISC_NAME_ISCMR101_U
            Case FEDM_ISC_TYPE_CPRM02
                Result = FEDM_ISC_NAME_CPRM02
            Case FEDM_ISC_TYPE_CPR02
                Result = FEDM_ISC_NAME_CPRM02_U
            Case FEDM_ISC_TYPE_CPRM02_U
                Result = FEDM_ISC_NAME_CPR02
            Case FEDM_ISC_TYPE_CPR02_U
                Result = FEDM_ISC_NAME_CPR02_U
            Case FEDM_ISC_TYPE_CPRM03
                Result = FEDM_ISC_NAME_CPRM03
            Case FEDM_ISC_TYPE_CPR03
                Result = FEDM_ISC_NAME_CPR03
            Case FEDM_ISC_TYPE_CPR04
                Result = FEDM_ISC_NAME_CPR04
            Case FEDM_ISC_TYPE_CPR04_U
                Result = FEDM_ISC_NAME_CPR04_U
            Case FEDM_ISC_TYPE_ISCLRU1000
                Result = FEDM_ISC_NAME_ISCLRU1000
            Case FEDM_ISC_TYPE_ISCLRU2000
                Result = FEDM_ISC_NAME_ISCLRU2000
            Case Else
                Result = "unbekannter Typ"
        End Select
        Return Result
    End Function

    Public Function GetErrorText(ByVal iStatus As Integer) As String
        Dim Result As String
        LastErrorID = iStatus
        Select Case iStatus
            Case &H0 : Result = "OK"
                '   Statusmeldung vom Reader
            Case &H1 : Result = "Reader: No Transponder in Reader Field"
            Case &H2 : Result = "Transponder: CRC Error"
            Case &H3 : Result = "Transponder: Write Error"
            Case &H4 : Result = "Transponder: Adress Error"
            Case &H5 : Result = "Reader: Wrong Transponder Type"
            Case &H6 : Result = "Transponder: Read Error"
            Case &H7 : Result = "Reader: Select Error"
            Case &HA : Result = "Reader: Transponder Changed"
            Case &HB : Result = "Transponder: Collision"
            Case &HC : Result = "Transponder: Weak Collision"
            Case &HD : Result = "Transponder: Halt Error"
            Case &HE : Result = "Reader: No New Selected Transponders"
            Case &HF : Result = "Reader: Busy"
            Case &H10 : Result = "Reader: EEPROM Error"
            Case &H11 : Result = "Reader: Parameter Range Error"
            Case &H80 : Result = "Reader: Unknown Command"
            Case &H81 : Result = "Reader: Protocol Length Error"
            Case &H82 : Result = "Reader: Command not available"
            Case &H83 : Result = "Reader: RF Communication Error"
            Case &H90 : Result = "Reader: Data Buffer Overrun"
            Case &H92 : Result = "Reader: No Valid Data"
            Case &H93 : Result = "Reader: Data Buffer Overflow"
            Case &H94 : Result = "Reader: Poll Buffer Overflow"

                '   Fehlertexte fr FECOM
            Case -1000 : Result = "FECOM: Fehler beim Erstellen eines neuen Port-Objekts"
            Case -1001 : Result = "FECOM: Port-Handleliste ist leer"
            Case -1002 : Result = "FECOM: ein Zeiger ist Null, also ungltig"
            Case -1003 : Result = "FECOM: Speichermangel"
            Case -1004 : Result = "FECOM: nicht untersttzte Hardware."
            Case -1005 : Result = "FECOM: Rckgabe FECOM_DetectPort, Port nicht vorhanden"
            Case -1006 : Result = "FECOM: nicht untersttzte Funktion oder Option"

            Case -1010 : Result = "FECOM: Fehler beim ffnen des COM-Ports"
            Case -1011 : Result = "FECOM: Timeout beim ffnen des COM-Ports"
            Case -1012 : Result = "FECOM: Fehlerhafter Parameter cPortNr in FECOM_OpenPort"
            Case -1013 : Result = "FECOM: der Port ist bereits geffnet"

            Case -1020 : Result = "FECOM: Unbekannter Port-Handle"
            Case -1021 : Result = "FECOM: Der bergebene Port-Handle ist null"
            Case -1022 : Result = "FECOM: Der bergebene Port-Handle ist negativ"
            Case -1023 : Result = "FECOM: Der bergebene Port-Handle ist unbekannt"

            Case -1030 : Result = "FECOM: Timeout beim Lesen vom Port"
            Case -1031 : Result = "FECOM: Kein Sendeprotokoll bergeben"
            Case -1032 : Result = "FECOM: Fehler im Empfangsprozess"
            Case -1033 : Result = "FECOM: Fehler beim Initialisieren des Ports"
            Case -1034 : Result = "FECOM: Fehler beim Lschen des Empfangspuffers"
            Case -1035 : Result = "FECOM: Fehler beim Lschen des Sendepuffers"
            Case -1036 : Result = "FECOM: Fehler beim ndern eines Port-Parameters"
            Case -1037 : Result = "FECOM: Fehler im Sendeprozess"
            Case -1038 : Result = "FECOM: Checksummen- und/oder Parittsfehler"
            Case -1039 : Result = "FECOM_ERR_READ_PORT_PARA"

            Case -1050 : Result = "FECOM: bergabeparameter ist nicht bekannt"
            Case -1051 : Result = "FECOM: bergabeparameter zu gro oder zu klein"
            Case -1052 : Result = "FECOM: Ungerader Parameterstring bergeben"
            Case -1053 : Result = "FECOM: COM-Port-Nummer auerhalb des gltigen Wertebereichs"
            Case -1054 : Result = "FECOM: unbekannter Fehlercode"

            Case -1070 : Result = "FECOM: berlauf im Empfangspuffer"

                '   Fehlertexte fr FEISC
            Case -4000 : Result = "FEISC: Fehler beim Erzeugen eines neuen Leser-Objekts"
            Case -4001 : Result = "FEISC: Leere Leser-Liste"
            Case -4002 : Result = "FEISC: Zeiger auf bergabeparameter ist NULL"
            Case -4003 : Result = "FEISC: Kein Systemspeicher mehr"
            Case -4004 : Result = "FEISC: unbekannter COM-Port"
            Case -4005 : Result = "FEISC: nicht untersttzte Funktion"
            Case -4006 : Result = "FEISC: keine USB-Untersttzung (z.B. unter NT4)"
            Case -4007 : Result = "FEISC: alte FECOM.DLL detektiert"
                ' query errors
            Case -4010 : Result = "FEISC: Kein Datenwert vorhanden"

            Case -4020 : Result = "FEISC: Reader-Handle ist unkekannt"
            Case -4021 : Result = "FEISC: Der bergebene Leser-Handlle ist null"
            Case -4022 : Result = "FEISC: Der bergebene Leser-Handle ist negativ"
            Case -4023 : Result = "FEISC: Reader-Handle in Reader-Handleliste"
            Case -4024 : Result = "FEISC: Der bergebene Port-Handle ist negativ"
            Case -4025 : Result = "FEISC: das erste Byte (MSB) im Port-Handle ist ungltig"

            Case -4030 : Result = "FEISC: Protokoll-Lngenfehler"
            Case -4031 : Result = "FEISC: Protokoll-Checksummenfehler"
            Case -4032 : Result = "FEISC: Busy-Timeout"

            Case -4050 : Result = "FEISC: Unbekannter bergabeparameter"
            Case -4051 : Result = "FEISC: bergabeparameter auerhalb des gltigen Wertebereichs"
            Case -4052 : Result = "FEISC: Ungerader Parameterstring bergeben"
            Case -4053 : Result = "FEISC: Parameterstring ist zu lang"

                'Public Const FEISC_ERR_NO_PLUGIN = -4060
                'Public Const FEISC_ERR_PLUGIN_PRESENT = -4061
                'Public Const FEISC_ERR_UNKNOWN_PLUGIN_ID = -4062
                'Public Const FEISC_ERR_PI_BUILD_DATA = -4063
                'Public Const FEISC_ERR_PI_BUILD_FRAME = -4064
                'Public Const FEISC_ERR_PI_SPLIT_FRAME = -4065
                'Public Const FEISC_ERR_PI_SPLIT_DATA = -4066



                '   Fehlertexte fr LUCA
            Case -10001 : Result = "COM-Port: unknown usual parameter"
            Case -10002 : Result = "COM-Port: unknown port handle"
            Case -10003 : Result = "COM-Port: to many ports open"
            Case -10004 : Result = "COM-Port: no more memory"

            Case -10010 : Result = "COM-Port: error in link identifier"
            Case -10011 : Result = "COM-Port: syntax error in parameter"
            Case -10012 : Result = "COM-Port: syntx error in value assignment"
            Case -10013 : Result = "COM-Port: syntx error in adress assignment"
            Case -10014 : Result = "COM-Port: parameterstring is to long"
            Case -10016 : Result = "COM-Port: input/output error"
            Case -10017 : Result = "COM-Port: timeout"
            Case -10018 : Result = "COM-Port: buffer is to small for next block"
            Case -10020 : Result = "COM-Port: value is out of range"
            Case -10021 : Result = "COM-Port: unknown parameter"
            Case -10022 : Result = "COM-Port: parameter is write protected"

            Case -10099 : Result = "COM-Port: not implemented"

            Case -20001 : Result = "COM-Port: abort"
            Case -20002 : Result = "COM-Port: modul not found"
            Case -20003 : Result = "COM-Port: unknown driver modul"
            Case -20005 : Result = "COM-Port: unknown protocol modul"
            Case -20006 : Result = "COM-Port: modul is still pushed"
            Case -20007 : Result = "COM-Port: missing adress"
            Case -20008 : Result = "COM-Port: missing protocol"

            Case -21000 : Result = "COM-Port: line is not ready"
            Case -21001 : Result = "COM-Port: timeout while connecting"
            Case -21002 : Result = "COM-Port: wrong network adress"
            Case -21003 : Result = "COM-Port: dial locked"
            Case -21004 : Result = "COM-Port: no dialtone"
            Case -21005 : Result = "COM-Port: <listen fehlgeschlagen>"
            Case -21006 : Result = "COM-Port: abnormal disconnect"

            Case -22000 : Result = "COM-Port: protocol error"

            Case -23001 : Result = "COM-Port: access denied"
            Case -23002 : Result = "COM-Port: authorization error"

            Case Else : Result = "unbekannter Fehlercode"
        End Select
        Info_Text = iStatus.ToString & "/" & Result
        RaiseEvent GetReaderText(Info_Text)
        Return Result
    End Function

#End Region

End Class
